<%init_ado_runtime6_js()%>

<SCRIPT runat="server" language="VBScript">
' *****************************************************************************
'
' include/ado.runtime6.asp
'
' GoLive runtime support for Microsoft ADO.
'
' ADOBE SYSTEMS INCORPORATED
' Copyright 1999-2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
' License Agreement, Adobe permits you to reproduce and distribute this 
' file only as an integrated part of a web site created with Adobe 
' GoLive software and only for the purpose of enabling your client to 
' display their web site. All other terms of the Adobe license 
' agreement remain in effect.
'
' -----------------------------------------------------------------------------

function GetMaxPendingRows(rs)
	GetMaxPendingRows = 0
	if False = RuntimeDebug then
		on error resume next
	end if
	GetMaxPendingRows = rs.Properties("Maximum Pending Rows").Value
end function

function testIndexColumns(index)
	if False = RuntimeDebug then
		on error resume next
	end if
	dim count
	count = index.Columns.Count
	if Err then
		testIndexColumns = false
	else
		testIndexColumns = true
	end if
end function

</SCRIPT>

<SCRIPT runat="server" language="JScript">

// *****************************************************************************
// Global variables

// CursorTypeEnum
var adOpenForwardOnly;
var adOpenKeyset;
var adOpenDynamic;
var adOpenStatic;
var adOpenUnspecified;

// LockTypeEnum
var adLockReadOnly;
var adLockPessimistic;
var adLockOptimistic;
var adLockBatchOptimistic;
var adLockUnspecified;

// DataTypeEnum
var AdArray;
var adEmpty;
var adSmallInt;
var adInterger;
var adSingle;
var adDouble;
var adCurrency;
var adDate;
var adBSTR;
var adIDispatch;
var adError;
var adBoolean;
var adVariant;
var adIUnknown;
var adDecimal;
var adTinyInt;
var adUnsignedTinyInt;
var adUnsignedSmallInt;
var adUnsignedInt;
var adBigInt;
var adUnsignedBigInt;
var adFileTime;
var adGUID;
var adBinary;
var adChar;
var adWChar;
var adNumeric;
var adUserDefined;
var adDBDate;
var adDBTime;
var adDBTimeStamp;
var adChapter;
var adPropVariant;
var adVarNumeric;
var adVarChar;
var adLongVarChar;
var adVarWChar;
var adLongVarWChar;
var adVarBinary;
var adLongVarBinary;

var adSchemaTables;
var adSchemaProviderTypes;


// *****************************************************************************
// Initialize JScript part

function init_ado_runtime6_js(msg)
{
	// CursorTypeEnum
	adOpenForwardOnly	= 0;
	adOpenKeyset		= 1;
	adOpenDynamic		= 2;
	adOpenStatic		= 3;
	adOpenUnspecified	= -1;
	
	// LockTypeEnum
	adLockReadOnly			= 1;
	adLockPessimistic		= 2;
	adLockOptimistic		= 3;
	adLockBatchOptimistic	= 4;
	adLockUnspecified		= -1;
	
	// DataTypeEnum
	AdArray				= 0x2000;
	adEmpty				= 0;
	adSmallInt			= 2;
	adInterger			= 3;
	adSingle			= 4;
	adDouble			= 5;
	adCurrency			= 6;
	adDate				= 7;
	adBSTR				= 8;
	adIDispatch			= 9;
	adError				= 10;
	adBoolean			= 11;
	adVariant			= 12;
	adIUnknown			= 13;
	adDecimal			= 14;
	adTinyInt			= 16;
	adUnsignedTinyInt	= 17;
	adUnsignedSmallInt	= 18;
	adUnsignedInt		= 19;
	adBigInt			= 20;
	adUnsignedBigInt	= 21;
	adFileTime			= 64;
	adGUID				= 72;
	adBinary			= 128;
	adChar				= 129;
	adWChar				= 130;
	adNumeric			= 131;
	adUserDefined		= 132;
	adDBDate			= 133;
	adDBTime			= 134;
	adDBTimeStamp		= 135;
	adChapter			= 136;
	adPropVariant		= 138;
	adVarNumeric		= 139;
	adVarChar			= 200;
	adLongVarChar		= 201;
	adVarWChar			= 202;
	adLongVarWChar		= 203;
	adVarBinary			= 204;
	adLongVarBinary		= 205;
	
	adSchemaTables = 20;
	adSchemaProviderTypes = 22;
	
	return;
}


// *****************************************************************************
// CONSTANTS
//


/*
 * placeholder to allow pages to work during switchover from
 * WrapRecordSet -> ADORecordSet
 */
function ADORecordSet(dataSource, sql, records, primaryKeySet, name)
{
	var recordSet = new ActiveXObject("ADODB.RecordSet");
	recordSet.Open(String(sql), ConnectString(dataSource));
	var csw = WrapRecordSet(recordSet, records, primaryKeySet, name);
	return csw;
}


/*
 * CONTENT SOURCE WRAPPER: ADO RECORDSET
 *
 * Content source wrapper for ADO RecordSet.
 *
 * Items are accessed through the wrapper as follows:
 *
 *	  set csw = WrapRecordSet(adoRecordSet, records, primaryKeySet)
 *	  csw.Value("SKU")
 *
 * RECORDS:
 * RECORDS controls the initialisations of csw.{First,Last}RecordOnPage
 * and csw.BlockCount to determine how many records will be displayed
 * on the page.  RECORDS values are
 *		block=0
 * - display all records
 *		block=1
 * - display only 1 record
 *		block=N
 * - display (at most) N records
 * The first record to be displayed is determined by the request
 * parameters RECORD_{KEY,INDEX}; if neither is present, choose
 * record #1.
 *
 * PRIMARYKEYSET:
 * In order to update/delete records, we need to identify them;
 * we do so by determining the database table's primary key.
 * Not all datasouces make the primary key available as metadata
 * (e.g., OLE dbs do, but ODBC-accessed dbs don't): for these cases,
 * the user can provide the primary key on his own using the
 * PRIMARYKEYSET parameter (a comma-separated list of the column names
 * that form the primary key).
 */
function WrapRecordSet(adoRecordSet, records, primaryKeySet, name)
{
	var csw = new CSWRecordSet(adoRecordSet, primaryKeySet);
	csw.Name = name;

	/*
	 * Determine the block size (i.e., number of records to
	 * display) as requested by the page.
	 */
	if (/^block=(\d+)/.test(records)) {
		csw.BlockSize = Number(RegExp.$1);
	} else {	// old version compatibility
		if (records == "single") {
			csw.BlockSize = 1;
		}
		if (records == "all") {
			csw.BlockSize = 0;
		}
	}

	/*
	 * We've already called csw.MoveFirst() to establish an
	 * initial position.  Here check the Request parameters for
	 * a record position; if one exists, move to that record.
	 */
	if (csw.BlockSize != 0) {
		var key = Request.QueryString("RECORD_KEY[" + csw.Name + "]");
		if (key.Count > 0) {
			csw.MoveToKey(key);
		}
		var index = Request.QueryString("RECORD_INDEX[" + csw.Name + "]");
		if (index.Count > 0) {
			csw.Move(Number(index) - 1);
		}
	}

	/*
	 * Set {First,Last}RecordOnPage.
	 */
	csw.FirstRecordOnPage = csw.AbsolutePosition;
	if (csw.BlockSize == 0) {	//	"all" case
		csw.LastRecordOnPage = csw.RecordCount;
	} else {
		csw.LastRecordOnPage = csw.FirstRecordOnPage + csw.BlockSize - 1;
		csw.LastRecordOnPage = (csw.LastRecordOnPage < csw.RecordCount ? csw.LastRecordOnPage : csw.RecordCount);
	}
	/* Fix up EOB and EOF. */
	csw_FixCursor(csw);

	/* Debugging output: delete before shipping. */
	if (RuntimeDebug) {
		var msg = "CSW Info:<br>\n";
		msg += "<table border=\"1\">\n";
		msg += "<tr><td>SQL</td><td>"	+ csw.Data.Source + "</td></tr>\n";
		msg += "<tr><td>CSW.Name</td><td>" + csw.Name + "</td></tr>\n";
		msg += "<tr><td>CSW.RecordCount</td><td>" + csw.RecordCount + "</td></tr>\n";
		msg += "<tr><td>CSW.AbsolutePosition</td><td>" + csw.AbsolutePosition + "</td></tr>\n";
		msg += "<tr><td>CSW.FirstRecordOnPage</td><td>" + csw.FirstRecordOnPage + "</td></tr>\n";
		msg += "<tr><td>CSW.LastRecordOnPage</td><td>" + csw.LastRecordOnPage + "</td></tr>\n";
		msg += "<tr><td>CSW.BlockSize</td><td>" + csw.BlockSize + "</td></tr>\n";
		msg += "</table>\n";
		RuntimeDebugMessage(msg);
	}

	/*
	 * If there's an error record from the previous form submission,
	 * overlay the content source with it.
	 */
	csw.cswerr = GetError();

	return csw;
}


// -----------------------------------------------------------------------------

function CSWRecordSet(adoRecordSet, primaryKeySet)
{
	// Method table:
	this.Move		 = CSWRecordSet_Move;
	this.MoveFirst	 = CSWRecordSet_MoveFirst;
	this.MoveNext	 = CSW_MoveNext;
	this.Value		 = CSWRecordSet_Value;
	this.Error		 = CSWRecordSet_Error;
	this.Key		 = CSWRecordSet_Key;
	this.MoveToKey	 = CSWRecordSet_MoveToKey;
    this.NestedCSW   = CSWRecordSet_NestedCSW;

	this.Data		= adoRecordSet;
	this.maxpending = GetMaxPendingRows(adoRecordSet);
	this.PrimaryKeySet = DeterminePrimaryKeySet(adoRecordSet, primaryKeySet);

	this.RecordCount = 0;
	// TODO: optimize
	while (!adoRecordSet.EOF) {
		this.RecordCount++;
		adoRecordSet.MoveNext();
	}

	this.AbsolutePosition = 0;
	this.dup_hack = -1;				// duplicate record hack
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = 0;
	this.BlockSize = 0;
	this.EOB = false;
	this.EOF = false;

	this.setupArgs = new Array;

	this.NewRecord = false;
	this.MoveFirst();
}

// -----------------------------------------------------------------------------
// Get the table name from a SQL query.

function getTableNameFromSource(source)
{
	var tableName = "";
	var tokens = String(source).split(" ");
	for (var i = 0; i < (tokens.length -1); i++) {
		if (tokens[i].toUpperCase() == "FROM") {
			tableName = tokens[i+1];
			break;
		}
	}
	return tableName;
}

// -----------------------------------------------------------------------------
// Not all datasources allow us to determine the primary keys, so:
//	First  priority: user specified primary key field
//	Second priority: automatic discovery of primary key for (OLE DB only)
//	Third  priority: use all fields that aren't long text

function DeterminePrimaryKeySet(adoRecordSet, userSpecifiedPrimaryKeySet)
{
	if (userSpecifiedPrimaryKeySet) {
		var temp = String(userSpecifiedPrimaryKeySet).split(" ").join("");
		return temp.split(",");
	}

	//
	// Attempt discovery:
	//
	if (RuntimeDebug) {
		RuntimeDebugMessage("Warning: No primary key set specified");
	}
	var primaryKeySet = new Array;
	var	primaryKeyCounter = 0;
	var	indexColumnsSupport = true;
	var tableName = getTableNameFromSource(adoRecordSet.Source);

	if (tableName == "")
	{
		indexColumnsSupport = false;
	}
	else
	{
		var catalog = new ActiveXObject("ADOX.Catalog");
		catalog.ActiveConnection = adoRecordSet.ActiveConnection;
		var table	= new ActiveXObject("ADOX.Table");
		table = catalog.Tables.Item(String(tableName));

		for (var k = 0; k < table.Indexes.Count; k++) {
			var index = new ActiveXObject("ADOX.Index");
			index = table.Indexes.Item(k);
			if (!index.PrimaryKey) {
				continue;	//	skip non-primary key
			}
			if (testIndexColumns(index)) {	// supported
				for (var m = 0; m < index.Columns.Count; m++) {
					var column	= new ActiveXObject("ADOX.Column");
					column = index.Columns.Item(m);
					var n = 0;
					for (n = 0; n < table.Columns.Count; n++) {
						var column2	 = new ActiveXObject("ADOX.Column");
						column2 = table.Columns.Item(n);
						if (column.Name == column2.Name) {
							break;
						}
					}
					if (n < table.Columns.Count) {
						var o = 0;
						for (o = 0; o < primaryKeySet.length; o++) {
							if (column.Name == primaryKeySet[o].Name) {
								break;
							}
						}
						if (primaryKeySet.length <= o) {
							primaryKeySet[primaryKeyCounter++] = column.Name;
						}
					}
				}
			} else {	//	not supported
				indexColumnsSupport = false;
				break;
			}
		}
	}

	if (indexColumnsSupport && primaryKeyCounter > 0) {
		return primaryKeySet;
	}

	//
	// Automatic discovery failed; concat non-long-text column names:
	//
	var knownkey = false;
	for (var i = 0; i < adoRecordSet.fields.count; i++) {
		var field = adoRecordSet.fields.item(i);
		var attrib = field.Attributes;
		if ((attrib & 0x100) && (attrib != -1)) {
			primaryKeySet = new Array(field.Name);
			break;
		}
		if (knownkey) {
			if ((attrib & 0x8000) && (attrib != -1)) {
				primaryKeySet = primaryKeySet.concat(Array(field.Name));
			}
		} else {
			if (attrib == -1) {
				primaryKeySet = primaryKeySet.concat(Array(field.Name));
			} else if (attrib & 0x8000) {
				primaryKeySet = new Array(field.Name);
				knownkey = true;
			} else if (!(attrib & 0x80)) {
				primaryKeySet = primaryKeySet.concat(Array(field.Name));
			}
		}
	}
	return primaryKeySet;
}

// -----------------------------------------------------------------------------
// Hierarchical recordsets:

function CSWRecordSet_NestedCSW(name)
{
	if (typeof(this.Nested[name]) == "undefined") {
        this.Nested[name] = null;
        if (!this.EOF) {
		    var field = this.Data.fields.item(name);
		    if (field.Type == adChapter) {
			    this.Nested[name] = WrapRecordSet(field.Value, "all");
		    }
	    }
    }

    return this.Nested[name];
}

// -----------------------------------------------------------------------------
// Cursor positioning:

function CSWRecordSet_Move(delta)
{
	if (delta > 0) {
		this.AbsolutePosition += Number(delta);
		this.EOB = (this.AbsolutePosition > this.LastRecordOnPage);
		this.EOF = (this.AbsolutePosition > this.RecordCount);
		if (!this.EOF) {
			this.Data.Move(delta);
		}
        this.Nested = new Object;
	}
}

function CSWRecordSet_MoveFirst()
{
	this.AbsolutePosition = 1;
	csw_FixCursor(this);
	if (this.RecordCount > 0) {
		this.Data.MoveFirst();
	}
    this.Nested = new Object;
}

// -----------------------------------------------------------------------------
// Data access:

function CSWRecordSet_Value(fieldName)
{
	var cswerr = this.cswerr;
	if (cswerr) {
		csw_MoveTo(cswerr, this.AbsolutePosition);
		var oe = cswerr.Value(fieldName);
		if (oe != null)
			return oe;
	}
	if (this.EOF) {
		if (this.dup_hack >= 0) {
			return this.Data.fields.item(fieldName);
		}
		return "";	// new record
	}
	try
	{
		return this.Data.fields.item(fieldName);
	}
	catch(e)
	{
		return "";
	}
}

function CSWRecordSet_Error(fieldName)
{
	var cswerr = this.cswerr;
	if (cswerr) {
		csw_MoveTo(cswerr, this.AbsolutePosition);
		var oe = cswerr.Error(fieldName);
		if (oe != "")
			return oe;
	}
	return "";
}

// -----------------------------------------------------------------------------
// Key-based data access:
//
// The primary key specification is stored as an array of column names.	 An
// instance of a key is of the format:
//    colName1,colName2,...&colName1=value&colName2=value....

function CSWRecordSet_Key()
{
	if ((this.EOF)||(String(Request("QUERY_STRING")).indexOf("$copyRecord") >= 0)) {
		return "$newRecord";
	}

	var keyLengthLimit = 255 - String(Request.ServerVariables("PATH_INFO")).length - 50;  // 50 is extra margin for server name
	var fieldLengthLimit = Math.max(4, ((keyLengthLimit / this.PrimaryKeySet.length) / 6)); //	 Min 4 is for "null". 6 is worst case for 2 byte char encoded.

	var key = "";
	var keyField = "";
	for (var i = 0; i < this.PrimaryKeySet.length; i++) {
		var keyName = this.PrimaryKeySet[i];
		var keyNameCsw = keyName + "[" + this.Name + "]";
		if (key.length + keyName.length + fieldLengthLimit + 1 > keyLengthLimit) {
			break;
		}
		if (i > 0) {
			key += "&";
			keyField += ",";
		}
		switch(this.Data.fields.item(keyName).Type) {
			case adDate:
			case adDBDate:
			case adDBTime:
			case adDBTimeStamp:
				if ((this.Data.fields.item(keyName) == null) || (String(this.Data.fields.item(keyName)).toUpperCase() == "NULL")) {
					key += escape(keyNameCsw) + "=" + escape("null");
					keyField += keyName;
				} else {
					key += escape(keyNameCsw) + "=" + escape(callVBFormatDateTime(this.Data.fields.item(keyName)));
					keyField += keyName;
				}
				break;
			case adBSTR:
			case adChar:
			case adWChar:
			case adVarChar:
			case adLongVarChar:
			case adVarWChar:
			case adLongVarWChar:
				if ((this.Data.fields.item(keyName) == null) || (String(this.Data.fields.item(keyName)).toUpperCase() == "NULL")) {
					key += escape(keyNameCsw) + "=" + escape("null");
					keyField += keyName;
				} else {
					key += escape(keyNameCsw) + "=" + escape(String(this.Data.fields.item(keyName)).substr(0, fieldLengthLimit));
					keyField += keyName;
				}
				break;
			default:
				if ((this.Data.fields.item(keyName) == null) || (String(this.Data.fields.item(keyName)).toUpperCase() == "NULL")) {
					key += escape(keyNameCsw) + "=" + escape("null");
					keyField += keyName;
				} else {
					key += escape(keyNameCsw) + "=" + escape(this.Data.fields.item(keyName));
					keyField += keyName;
				}
				break;
		}
	}
	if (RuntimeDebug) {
		var testString = escape(keyField) + "&" + key;
		if (keyLengthLimit < testString.length) {
			RuntimeDebugMessage("Warning: Generated key length is too long.");
		}
	}
	return escape(keyField) + "&" + key;
}


function CSWRecordSet_MoveToKey(key)
{
	if (key == "$newRecord") {
		this.Move(this.RecordCount);
		return;
	}

	if (key == "$lastRecord") {
		this.Move(this.RecordCount-1);
		return;
	}

	this.MoveFirst();
	var keys = new Array;
	if (key == "$queryString") {	//	this part is version 1 compatibility.
		var keyString = Request.QueryString("$key");
		if (keyString.Count < 1)	return;
		var rawKeys = String(unescape(keyString)).split("&");
		for (var i = 0; i < rawKeys.length; i++) {
			var keyDelim = rawKeys[i].indexOf("=");
			var name  = unescape(rawKeys[i].substring(0, keyDelim));
			var value = unescape(rawKeys[i].substring(keyDelim + 1));
			keys[name] = value;
		}
	} else {
		var keyName = String(key).split(",");
		for (var i = 0; i < keyName.length; i++) {
			if( keyName[i] == "$copyRecord" ) {
				continue;
			}
			var name  = keyName[i];
			var value = String(Request.QueryString(keyName[i]+"["+this.Name+"]"));
			keys[name] = value;
		}
	}
	while (!this.EOF) {
		var match = true;
		for (var i = 0; i < this.Data.fields.count; i++) {
			var field = this.Data.fields.item(i);
			var stringField = String(field);
			if ((field.Type == adDate) || (field.Type == adDBDate) || (field.Type == adDBTime) || (field.Type == adDBTimeStamp)) {
				stringField = callVBFormatDateTime(field);
			}
			for (var name in keys) {
				if ((field.Name == name)&&(stringField.indexOf(keys[name]) != 0)) {
					match = false;
					break;
				}
			}
		}
		if (match) {
			if (String(key).indexOf("$copyRecord") == 0) {
				this.dup_hack = this.AbsolutePosition;
				this.AbsolutePosition = this.RecordCount + 1;
			}
			return;
		}
		this.MoveNext();
	}
}

// *****************************************************************************
// ACTION SETUP ROUTINES

// -----------------------------------------------------------------------------

function MakeADOReturnURL(contentSource, url)
{
	var thisPage = Request("URL");
	if (url == "$return") {
		//
		// All record page:
		//
		if (contentSource.BlockSize == 0) {
			return thisPage;
		}

		//
		// Remove the record keys since they won't work after an update/delete/etc:
		//
		var oldArgs = queryStringToArray(String(Request.QueryString));
		var newArgs = new Array;
		for (var name in oldArgs) {
			if ((name != "$key") && (name != ("RECORD_KEY[" + contentSource.Name + "]"))) {
				if (name.indexOf(contentSource.Name) == -1 ) {
					newArgs[name] = oldArgs[name];		// keep it does not have cswName
				} else {
					if (name.indexOf("RECORD_INDEX") != -1) {
						newArgs[name] = oldArgs[name];	// keep RECORD_INDEX case
					}
				}
			}
		}

		if (typeof(oldArgs["RECORD_KEY[" + contentSource.Name + "]"]) != "undefined" ) {
			switch(oldArgs["RECORD_KEY[" + contentSource.Name + "]"]) {
				case "$copyRecord":	// Special processing if the last action was a copyRecord:
				case "$newRecord":	// Special processing if the last action was a newRecord:
					newArgs["RECORD_INDEX[" + contentSource.Name + "]"] = contentSource.RecordCount + 1;
					break;
				case "$lastRecord":	// Special processing if the last action was a lastRecord:
					newArgs["RECORD_INDEX[" + contentSource.Name + "]"] = contentSource.RecordCount;
					break;
				default:			// RECORD_KEY => RECORD_INDEX
					newArgs["RECORD_INDEX[" + contentSource.Name + "]"] = contentSource.AbsolutePosition;
					break;
			}
		}

		return thisPage + "?" + queryArrayToString(newArgs);
	} else {
		return absolutePath(thisPage, url);
	}
}

// -----------------------------------------------------------------------------

function SetupADOUpdate(successLink, failureLink, contentSource)
{
	contentSource.setupArgs["update_success"] = MakeADOReturnURL(contentSource, successLink);
	contentSource.setupArgs["update_failure"] = MakeADOReturnURL(contentSource, failureLink);
}

// -----------------------------------------------------------------------------

function SetupADOAdd(successLink, failureLink, contentSource)
{
	contentSource.setupArgs["add_success"] = MakeADOReturnURL(contentSource, successLink);
	contentSource.setupArgs["add_failure"] = MakeADOReturnURL(contentSource, failureLink);
}

// -----------------------------------------------------------------------------

function SetupADODelete(successLink, failureLink, contentSource)
{
	contentSource.setupArgs["delete_success"] = MakeADOReturnURL(contentSource, successLink);
	contentSource.setupArgs["delete_failure"] = MakeADOReturnURL(contentSource, failureLink);
}

// -----------------------------------------------------------------------------

function SetupADOClear(successLink, failureLink, contentSource)
{
	contentSource.setupArgs["clear_success"] = MakeADOReturnURL(contentSource, successLink);
	contentSource.setupArgs["clear_failure"] = MakeADOReturnURL(contentSource, failureLink);
}

// -----------------------------------------------------------------------------

function SetupADOCopy(successLink, failureLink, contentSource)
{
	contentSource.setupArgs["copy_success"] = MakeADOReturnURL(contentSource, successLink);
	contentSource.setupArgs["copy_failure"] = MakeADOReturnURL(contentSource, failureLink);
}

// -----------------------------------------------------------------------------
// Attributes in HTML elements must be HTML encoded

function MakeHidden(name, value)
{
	return "<input type='hidden' name='" + Server.HTMLEncode(name) + "' value='" + Server.HTMLEncode(value) + "'>";
}

// -----------------------------------------------------------------------------
// Setup the form.  This function must at least write out the setup arguments
// added by the individual action setup functions.

function SetupADOForm(contentSource)
{
	var hidden = new Array;

	//
	// If we got here from a form error redirect, then all the setup info has
	// been saved for us in the CSWFormError.
	//
	if (typeof(contentSource.DollarData) == "function") {
		var dollarData = contentSource.DollarData();
		for (var key in dollarData) {
			hidden[hidden.length] = MakeHidden(key, dollarData[key]);
		}
		return;
	}

	//
	// Write out the content source info:
	//
	hidden[hidden.length] = MakeHidden("$cswName", contentSource.Name);

	//
	// Write out the database info:
	//
	hidden[hidden.length] = MakeHidden("$connect", obscure(contentSource.Data.ActiveConnection.ConnectionString));
	hidden[hidden.length] = MakeHidden("$source", obscure(contentSource.Data.Source));
	var datatypes = new Array;
	for (var i = 0; i < contentSource.Data.Fields.Count; i++) {
		datatypes[datatypes.length] = contentSource.Data.Fields.Item(i).Name + "=" + contentSource.Data.Fields.Item(i).Type;
	}
	hidden[hidden.length] = MakeHidden("$datatypes", obscure(datatypes.join("&")));

	//
	// Write out the record key(s):
	//
	var first = contentSource.FirstRecordOnPage;
	var last = contentSource.LastRecordOnPage;
	hidden[hidden.length] = MakeHidden("$firstRecord", first);
	hidden[hidden.length] = MakeHidden("$lastRecord", last);
	hidden[hidden.length] = MakeHidden("$position", contentSource.AbsolutePosition);


//TODO: if there is a query parameter RECORD_KEY[csn]=$newRecord, then a $key[position]=$newReord
// should be written into the form according to the spec.  In this case, first should be > last.
	contentSource.MoveFirst();
	contentSource.Move(first - 1);
	while (contentSource.AbsolutePosition <= last) {
		var keyName = "$key[" + contentSource.AbsolutePosition + "]";
		var key = contentSource.Key();
		hidden[hidden.length] = MakeHidden(keyName, key);
		contentSource.MoveNext();
	}

	// Reset
	contentSource.MoveFirst();
	contentSource.Move(first - 1);

	//
	// Write out all the args collected from the SetupAction calls:
	//
	for (var key in contentSource.setupArgs) {
		hidden[hidden.length] = MakeHidden("$" + key, contentSource.setupArgs[key]);
	}
	contentSource.setupArgs = [];

	if (RuntimeDebug) {
		Response.Write(hidden.join("\n"));	// easy to see source code in debug mode
	} else {
		Response.Write(hidden.join(""));	// no return code in normal mode
	}
}

</SCRIPT>

