<SCRIPT runat="server" language="JScript">

/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2001-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

function NewCSWBlockView(records, viewed_csw, name) {
	var csn = new CSWBlockView(records, viewed_csw, name);
	return csn;
}

function CSWBlockView(records, viewed_csw, name) {
	/* Functions. */
	this.Error = CSWBlockView_Error;
	this.Key = CSWBlockView_Key;
	this.Move = CSWBlockView_Move;
	this.MoveFirst = CSWBlockView_MoveFirst;
	this.MoveNext = CSWBlockView_MoveNext;
	this.MoveTo = CSWBlockView_MoveTo;
	this.Value = CSWBlockView_Value;

	this.Name = name;
	this.RecordCount = 0;
	this.AbsolutePosition = 1;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = 0;
	this.BlockSize = 1;
	this.EOB = true;
	this.EOF = true;

	this.colname = new Array(
		null,
		'Block_Size',
		'First',
		'Last',
		'Link_URL',
		'Link_URL_checker',
		'Total_Records'
		);
	this.ncol = this.colname.length-1;
	this.viewed_csw = viewed_csw;
	var vbs = viewed_csw.BlockSize;
	this.RecordCount = (viewed_csw.RecordCount + vbs - 1) / vbs;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = this.RecordCount;
	var t = (viewed_csw.FirstRecordOnPage + vbs - 1) / vbs;
	this.MoveTo(t);

	var bs = this.RecordCount;
	if (records=='all')
		bs = this.RecordCount;
	else if (records=='single')
		bs = 1;
	else if (/^block=(\d+)/.test(records))
		bs = Number(RegExp.$1);
	this.BlockSize = bs;

	var ix = this.AbsolutePosition;
	this.FirstRecordOnPage = ix - (ix-1) % bs;
	var lastrec = this.FirstRecordOnPage + bs - 1;
	if (lastrec > this.RecordCount)
		lastrec = this.RecordCount;
	this.LastRecordOnPage = lastrec;
}

function CSWBlockView_Error() {
	return '';
}

function CSWBlockView_Key() {
	return this.viewed_csw.GetName();
}

function CSWBlockView_Move(delta) {
	this.MoveTo(this.AbsolutePosition + Number(delta));
}

function CSWBlockView_MoveFirst() {
	this.MoveTo(1);
}

function CSWBlockView_MoveNext() {
	this.MoveTo(this.AbsolutePosition + 1);
}

function CSWBlockView_MoveTo(n) {
	this.AbsolutePosition = n;
	csw_FixCursor(this);
}

function CSWBlockView_Value(field) {
	var c = this.viewed_csw;
	var vbs = c.BlockSize;
	var vn = c.RecordCount;
	var ix = this.AbsolutePosition;
	if (field=='BlockSize')
		return vbs;
	if (field=='First')
		return (ix-1)*vbs + 1;
	if (field=='Last') {
		var n = ix*vbs;
		return n < vn ? n : vn;
	}
	if (field=='Link_URL') {
		var link = linkToRecord(this, ix, true);
		if (/href="(.*)"/.test(link) || /href='(.*)'/.test(link))
			link = RegExp.$1;
		return link;
	}
	if (field=='Link_URL_checker') {
		var link = linkToRecord(this, ix);
		if (/href="(.*)"/.test(link) || /href='(.*)'/.test(link))
			link = 'OK';
		return link;
	}
	if (field=='Total_Records')
		return vn;
	return '';
}

</SCRIPT>
