<SCRIPT runat="server" language="JScript">
	
// *****************************************************************************
//
// include/xml.runtime6.asp
//
// GoLive runtime support for XML Data Sources
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
// 
// NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
// License Agreement, Adobe permits you to reproduce and distribute this 
// file only as an integrated part of a web site created with Adobe 
// GoLive software and only for the purpose of enabling your client to 
// display their web site. All other terms of the Adobe license 
// agreement remain in effect.
//

function GetXMLSource(records, dstype, xmlurl, name)
{
	var dsfilename = GetDataSourcePath() + dstype + ".XDS";
	var doc;
	try
	{
		doc = new ActiveXObject("MSXML2.DOMDocument");
	}
	catch(e) {}
	if (!doc) {
		doc = new ActiveXObject("Microsoft.XMLDOM");
	}
	doc.async = false;
	doc.load(dsfilename);
	var xslurl = doc.documentElement.getAttribute("xslurl");

	var recordLevel = (doc.documentElement.getAttribute("single") == "true") ? "/*" : "/*/*";
	
	var xml = SafeLoad(xmlurl);
	
	if (String(xslurl).length > 0) {
		xml.transformNodeToObject(SafeLoad(xslurl), doc);
	} else {
		doc = xml;
	}

	var csw = new XMLSource(doc.selectNodes(recordLevel));
	csw.Name = name;

	/*
	 * Determine the block size (i.e., number of records to
	 * display) as requested by the page.
	 */
	if (/^block=(\d+)/.test(records)) {
		csw.BlockSize = Number(RegExp.$1);
	} else {	// old version compatibility
		if (records == "single") {
			csw.BlockSize = 1;
		}
		if (records == "all") {
			csw.BlockSize = 0;
		}
	}

	/*
	 * We've already called csw.MoveFirst() to establish an
	 * initial position.  Here check the Request parameters for
	 * a record position; if one exists, move to that record.
	 */
	if (csw.BlockSize != 0) {
		var key = Request.QueryString("RECORD_KEY[" + csw.Name + "]");
		if (key.Count > 0) {
			csw.MoveToKey(key);
		}
		var index = Request.QueryString("RECORD_INDEX[" + csw.Name + "]");
		if (index.Count > 0) {
			csw.Move(Number(index) - 1);
		}
	}

	/*
	 * Set {First,Last}RecordOnPage.
	 */
	csw.FirstRecordOnPage = csw.AbsolutePosition;
	if (csw.BlockSize == 0) {	//	"all" case
		csw.LastRecordOnPage = csw.RecordCount;
	} else {
		csw.LastRecordOnPage = csw.FirstRecordOnPage + csw.BlockSize - 1;
		csw.LastRecordOnPage = (csw.LastRecordOnPage < csw.RecordCount ? csw.LastRecordOnPage : csw.RecordCount);
	}
	/* Fix up EOB and EOF. */
	csw_FixCursor(csw);

	return csw;
}

function SafeLoad(url)
{
	/*
	If you try to load an XMLDOM object from an URL it may not work.
	And if you try to get from a file using XMLHTTP it doesn't work.
	And if you use XMLHTTP to get from an URL and the result is XML
	but the Content-Type header says it's something else, the
	responseXML property doesn't work. That's why all this gobbledygook.
	*/
	var doc;
	var oldxml = false;
	try
	{
		doc = new ActiveXObject("MSXML2.DOMDocument");
	}
	catch(e) {}
	if (!doc) {
		doc = new ActiveXObject("Microsoft.XMLDOM");
		oldxml = true;
	}
	doc.async = false;
	doc.validateOnParse = false;
	doc.resolveExternals = false;
	url = String(url); // oh, just in case
	if (url.substring(0, 5).toLowerCase() == "http:") {
		if (!doc.load(url)) {
			if (oldxml)
			{
				var http = new ActiveXObject("Microsoft.XMLHTTP");
				http.open("GET", url, false);
				http.send();
				if (http.responseXML.documentElement)
				{
					doc = http.responseXML;
				}
				else
				{
					doc.loadXML(http.responseText);
				}
			}
			else
			{
				doc.setProperty ("ServerHTTPRequest", true);
				if (!doc.load(url)) {
					var http = new ActiveXObject("MSXML2.ServerXMLHTTP");
					http.open("GET", url, false);
					http.send();
					if (http.responseXML.documentElement)
					{
						doc = http.responseXML;
					}
					else
					{
						doc.loadXML(http.responseText);
					}
				}
			}
		}
	} else {
		if (url.indexOf(":") == -1) {
			url = Server.MapPath(url);
		}
		doc.load(url);
	}
	return doc;
}

function XMLSource(nodeList)
{
	this.Move = XML_Move;
	this.MoveFirst = XML_MoveFirst;
	this.MoveNext = CSW_MoveNext;
	this.Value = XML_Value;
	this.Error = XML_Error;
	this.Key = XML_Key;
	this.MoveToKey = XML_MoveToKey;
	this.NestedCSW = XML_NestedCSW;

	this.data = nodeList;
	this.RecordCount = nodeList.length;
	this.BlockSize = this.RecordCount;
	this.dup_hack = -1;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = this.BlockSize;

	this.MoveFirst();
}

function XML_Move(delta)
{
	this.AbsolutePosition += delta;
	csw_FixCursor(this);
	this.current = this.data.item(this.AbsolutePosition - 1);
	this.Nested = new Object();
}

function XML_MoveFirst()
{
	this.AbsolutePosition = 1;
	csw_FixCursor(this);
	this.current = this.data.item(0);
	this.Nested = new Object();
}

function XML_NestedCSW(name)
{
	if (typeof(this.Nested[name]) == "undefined") {
		this.Nested[name] = this.current ? new XMLSource(this.current.selectNodes(name)) : null;
	}

	return this.Nested[name];
}

function XML_Value(fieldName)
{
	if (!this.current) {
		return "";
	}
	
	var node = this.current.selectSingleNode(fieldName);
	if (!node) {
		return "";
	}
		
	var result = "";
	var children = node.childNodes;
	for (var child = children.nextNode(); child; child = children.nextNode()) {
		switch (child.nodeType)
		{
		case 3:
		case 4:
			result = result + child.text;
			break;
		default:
			result = result + child.xml;
		}
	}
	return result;
}

function XML_Error(fieldName)
{
	return this.Value(fieldName + "/@error");
}

function XML_Key()
{
	return hash(this.current.xml);
}

function XML_MoveToKey(key)
{
	while (!this.EOF && (hash(this.current.xml) != key))
	{
		this.MoveNext();
	}
}

function hash(xml)
{
	var h = 0;
	var hiNibble = 15 << 28;
	for (var i = xml.length; i; i--)
	{
		h &= ~hiNibble;
		h <<= 4;
		h += xml.charCodeAt(i - 1);
		var g = h & hiNibble;

		if (g != 0)
		{
			h ^= g >> 24;
			h ^= g;
		}
	}
	return String(h);
}

</SCRIPT>
