<%@Language="VBScript"%>
<%Option Explicit%>
<!-- #INCLUDE FILE="troubleshootinginclude.asp" -->


<%
Response.ContentType = "text/html"
Response.CharSet = "windows-" & Session.CodePage
on error resume next

' --- troubleshooting.asp -----------------------------------------------------
' ADOBE SYSTEMS INCORPORATED
' Copyright 1999-2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
' License Agreement, Adobe permits you to reproduce and distribute this 
' file only as an integrated part of a web site created with Adobe 
' GoLive software and only for the purpose of enabling your client to 
' display their web site. All other terms of the Adobe license 
' agreement remain in effect.
'
' Adobe GoLive (ASP) Troubleshooting Report
'
' This Active Server Page file performs a series of tests to verify that
' the Adobe GoLive server files are properly installed and configured.
'
' IMPORTANT: This file is for troubleshooting purposes only.  You should not
' leave this file installed on a production server because it might provide
' users with information about your security setup and the structure of your
' datasource files.
' -----------------------------------------------------------------------------

' -----------------------------------------------------------------------------
' Call the main function, written in JScript, below.

main()

' -----------------------------------------------------------------------------
' These VBScript functions are utility functions for the tests, below.

function getVBScriptEngineVersion
	dim msg
	msg = ""

	msg = msg & ScriptEngineMajorVersion & "."
	msg = msg & ScriptEngineMinorVersion & "."
	msg = msg & ScriptEngineBuildVersion
	getVBScriptEngineVersion = msg
end function


function getVBScriptEngineMajorVersion
	getVBScriptEngineMajorVersion = ScriptEngineMajorVersion
end function


function writeServerVariables()
	dim msg, name
	msg = ""

	for each name in Request.ServerVariables
		msg = msg + "<tr><td>" & vbNewLine
		msg = msg +	 name & "" & vbNewLine
		msg = msg +	 "</td><td>" & vbNewLine
		msg = msg +	 Request.ServerVariables(name) & "<br>" & vbNewLine
		msg = msg +	 "</td></tr>" & vbNewLine
	next
	writeServerVariables = msg
end function


function testWriteFileOnServer(fso, virtualName)
on error resume next

	dim	fileName, folderName, testFile, fileData

	fileData = "GoLive Dynamic Link"
	fileName = Server.MapPath(virtualName)
	folderName = fso.GetParentFolderName(fileName)
	if not fso.FolderExists(folderName) then fso.CreateFolder(folderName)
	set testFile = fso.CreateTextFile(fileName, True)

	testFile.Write fileData
	testFile.Close
	fso.DeleteFile fileName, True

	if Err then
		testWriteFileOnServer = false
	else
		testWriteFileOnServer = true
	end if
end function


function testXmlDomSupport()
	on error resume next

	dim test
	set test = CreateObject("Microsoft.XMLDOM")

	if Err then
		testXmlDomSupport = false
	else
		testXmlDomSupport = true
	end if
end function


function testConnectionOpen(connection, connectString)
	on error resume next

	connection.Open(connectString)

	if Err then
		testConnectionOpen = false
	else
		testConnectionOpen = true
	end if
end function


function testOpenSchema(connection)
	on error resume next

	dim schema, msg
	set schema = connection.OpenSchema(20) ' 20: adSchemaTables = 20
	msg = ""

	if Err then
	else
		msg = msg + "Success</td><td>"
		do until schema.EOF
			if (schema("TABLE_TYPE") = "TABLE") then
				msg = msg + "<dl>" & vbNewLine
				msg = msg + "<dt>" & schema("TABLE_NAME") & vbNewLine
				msg = msg + listDataSourcesField(connection, schema("TABLE_NAME"))
				msg = msg + "</dl>" & vbNewLine
			end if
			schema.MoveNext
		Loop
	end if
	testOpenSchema = msg
end function


function testIndexColumns(index)
	on error resume next

	dim count
	count = index.Columns.Count

	if Err then
		testIndexColumns = false
	else
		testIndexColumns = true
	end if
end function


%>

<script runat="server" language="JScript">

// --- Test Creation Functions ------------------------------------------------
// These functions create a new Test object, perform a test, and return the
// Test object with the results.
// ----------------------------------------------------------------------------

function checkASPSoftware()
{
	var test = new Test("Check ASP software");
	test.description  = "This test checks to see whether your web server is enabled for Active Server Pages. ";
	test.description += "Note that IIS 2.0 requires an additional ASP pack. IIS 3 or later includes ASP support by default. ";
	test.description += "The IIS configuration (Site Management Console or other application) should have \"Script Enabled\" for the web site folder. ";

	test.Pass("ASP software is present.");

	return test;
}


function checkServerVersion()
{
	var test = new Test("Check Web server version");
	test.description = "This test checks to make sure your Microsoft IIS software version is 4.0 or later.";
	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Server variable</th><th>Value</th></tr>\n";
	test.details += "<tr><td>SERVER_SOFTWARE</td><td>" + Request.ServerVariables("SERVER_SOFTWARE") + "</td></tr>\n";
	test.details += "</table>\n";
	test.details += "<p>\n";

	var found = false;
	var server = String(Request.ServerVariables("SERVER_SOFTWARE"));
	if (server.match(/Microsoft-IIS\/(\d+)\.(\d+)/)) {
		var majorVersion = Number(RegExp.$1);
		var minorVersion = Number(RegExp.$2);
		if (majorVersion * 10 + minorVersion >= 40) {
			found = true;
		}
	}

	if (found) {
		test.Pass("ASP enabled web server \"" + server + "\" was found.");
	} else {
		test.Fail("Server version should be 4.0 or later.");
	}
	return test;
}


function checkScriptEngineVersion()
{
	var test = new Test("Check script engine version");
	test.description  = "This test checks to make sure your server script engine versions are 5.0 or later. ";
	test.description += "The script versions are depend on installed IIS or IE on the server. ";
	test.description += "If you install IIS 4.0, then you have version 3.0 script engine. ";
	test.description += "After that, if you install IE 5.0, then you will have version 5.0 script engine. ";
	test.description += "Windows 2000 comes with IIS 5, which has version 5.1 script engine. ";
	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Script language</th><th>Version</th></tr>\n";
	test.details += "<tr><td>JScript</td><td>" + ScriptEngineMajorVersion() + "." + ScriptEngineMinorVersion() + "." + ScriptEngineBuildVersion() + "</td></tr>\n";
	test.details += "<tr><td>VBScript</td><td>" + getVBScriptEngineVersion() + "</td></tr>\n";
	test.details += "</table>\n";
	test.details += "<p>\n";

	var JSVersion = ScriptEngineMajorVersion();
	var VBVersion = getVBScriptEngineMajorVersion();

	if ((5 <= JSVersion)&&(5 <= VBVersion)) {
		test.Pass("Both server script versions are 5.0 or later.");
	} else {
		test.Fail("Both server script version should be 5.0 or later.");
	}

	return test;
}


function checkMsXmlVersion()
{
	var test = new Test("Check MSXML version");
	test.description  = "This test checks to make sure your server MSXML versions are 3.0 or later. ";
	test.description += "You can get updater from Microsoft website (<a target=\"_blank\" ";
	test.description += "href=\"http://www.microsoft.com/xml/\">http://www.microsoft.com/xml/</a>). ";

	var xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><tagname></tagname>";

	var stride = 3;	//	object name, version, required
	var checkVersions = new Array(
		"Msxml2.DOMDocument",		"MSXML2",			false,
		"Msxml2.DOMDocument.2.6",	"MSXML2 ver 2.6",	false,
		"Msxml2.DOMDocument.3.0",	"MSXML2 ver 3.0",	true,
		"Msxml2.DOMDocument.4.0",	"MSXML2 ver 4.0",	true);

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Version</th><th>Check</th></tr>\n";

	var counter = 0;
	for (var i = 0; i < checkVersions.length; i += stride) {
		var objectString = checkVersions[i];
		var version 	 = checkVersions[i+1];
		var required 	 = checkVersions[i+2];

		test.details += "<tr><td>" + version + "</td><td>";
		try {
			var msxml = new ActiveXObject(objectString);
			msxml.async = false;
		    if (msxml.loadXML(xml)) {
				test.details += "<span class=\"Passed\">Installed</span>";
				counter += required ? 1 : 0;
		    }
		} catch(e) {
			test.details += "<span class=\"verify\">Not Installed: " ;
			test.details += e.description + "</span>";
		}
		test.details += "</td></tr>\n";
	}
	test.details += "</table>\n";
	test.details += "<p>\n";

	if (counter > 0) {
		test.Pass("Required MSXML version is installed.");
	} else {
		test.Fail("Required MSXML version is not installed.");
	}

	return test;
}


function checkXmlDomSupport()
{
	var test = new Test("Check XML DOM support");
	test.description  = "This test checks to make sure your server support XML DOM.";
	test.description += "If it is not supported, XML source contents feature and some ";
	test.description += "troubleshooting test won't work.";
	test.description += "In case of then, you can update IIS with installing IE 5 or later.";

	test.details = "Creating XML DOM on this server ";

	if (testXmlDomSupport()) {
		test.Pass("XML DOM is supported on this server.");
		test.details += "<span class=\"Passed\">was successful.</span>";
	} else {
		test.Fail("XML DOM is not supported on this server.");
		test.details += "<span class=\"Failed\">failed</span>";
	}
	test.details += ".<p>\n";

	return test;
}


function checkVirtualPathSetting()
{
	var test = new Test("Check virtual path setting");

	test.description  = "This test checks that the virtual path to your web site folder for your URL points to the correct place. ";
	test.description += "APPL_PHYSICAL_PATH is your virtual root setting. ";
	test.description += "PATH_TRANSLATED is the physical path setting for this page. ";
	test.description += "PATH_INFO, SCRIPT_NAME & URL contains the URL to this page without the hostname. ";

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Server variable</th><th>Value</th></tr>\n";
	test.details += "<tr><td>APPL_PHYSICAL_PATH </td><td>" + Request.ServerVariables("APPL_PHYSICAL_PATH") + "</td></tr>\n";
	test.details += "<tr><td>PATH_INFO          </td><td>" + Request.ServerVariables("PATH_INFO"		) + "</td></tr>\n";
	test.details += "<tr><td>PATH_TRANSLATED    </td><td>" + Request.ServerVariables("PATH_TRANSLATED"	) + "</td></tr>\n";
	test.details += "<tr><td>SCRIPT_NAME        </td><td>" + Request.ServerVariables("SCRIPT_NAME"		) + "</td></tr>\n";
	test.details += "<tr><td>URL                </td><td>" + Request.ServerVariables("URL"				) + "</td></tr>\n";
	test.details += "</table>\n";

	test.Verify("You should verify that your virtual path settings are correct.");

	return test;
}


function checkSessionStateSetting()
{
	var test = new Test("Check session state setting");

	test.description  = "This test checks the virtual root's session state. ";
	test.description += "CustomMerchant requires this setting to be enabled. ";
	test.description += "This setting can be set in Internet Service Manager or GLOBAL.ASA. ";
	test.description += "But if you don't want to enable the option (default is enabled) for the whole site or virtual folder, you can set it on each required page by using the &lt;%@ ENABLESESSIONSTATE=True|False%&gt; setting. ";

	var http_cookie = String(Request.ServerVariables("HTTP_COOKIE"));

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Server variable</th><th>Value</th></tr>\n";
	test.details += "<tr><td>HTTP_COOKIE</td><td>" + http_cookie + "</td></tr>\n";
	test.details += "</table>\n";
	test.details += "<p>\n";

	if (http_cookie.indexOf("ASPSESSIONID") != -1) {	// found
		test.Pass("ASP Session State is enabled.");
	} else {
		var msg = "Reload this page once. ";
		msg += "If this test still does not pass, ASP Session State is disabled. ";
		msg += "Database Update and CustomMerchant pages require it to be enabled."
		test.Verify(msg);
	}
	return test;
}


function checkPasswordSetting()
{
	var test = new Test("Check password setting of web server");

	test.description  = "This test checks whether the web server is set to require user names and passwords. If so, only basic authentication is supported by GoLive. ";
	test.description += "If any of the following server variables have a value, there is a password required to access the server. ";
	test.description += "In case of basic authentication, server variable HTTP_AUTHORIZATION's value will start \"Basic \". ";
	test.description += "Other http authentication methods are not supported. ";

	var auth_user	= Request.ServerVariables("AUTH_USER");
	var remote_user = Request.ServerVariables("REMOTE_USER");
	var logon_user	= Request.ServerVariables("LOGON_USER");
	var http_authorization = Request.ServerVariables("HTTP_AUTHORIZATION");
	var error = 0;

	if (((auth_user != "")&&(auth_user == "undefined"))||(remote_user != "")||(logon_user != "")) { //	(auth_user == "undefined") is IIS3 support
		if (String(http_authorization).indexOf("Basic") == 0) {
			error = 1;
		} else {
			error = 2;
		}
	}

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Server variable</th><th>Value</th></tr>\n";
	test.details += "<tr><td>AUTH_USER          </td><td>" + auth_user			 + "</td></tr>\n";
	test.details += "<tr><td>REMOTE_USER        </td><td>" + remote_user		 + "</td></tr>\n";
	test.details += "<tr><td>LOGON_USER         </td><td>" + logon_user			 + "</td></tr>\n";
	test.details += "<tr><td>HTTP_AUTHORIZATION </td><td>" + http_authorization	 + "</td></tr>\n";
	test.details += "</table>\n";

	switch(error) {
		case 0:
			test.Pass("Access is anonymous, requiring no password security.");
			break;
		case 1:
			test.Verify("Password protection is set as basic authentication.");
			break;
		case 2:
			test.Fail("Access is password protected. The listed user is logged on. To use GoLive this must be disabled. Use IP security with friends.asp instead.");
			break;
	}
	return test;
}


function checkServerConfigFiles()
{
	var test = new Test("Check server config files");

	test.description = "This test checks to see whether the ASP and XML files for GoLive have been properly installed on the server. It also produces a directory tree list of all files in the config folder. ";
	test.description += "The following files are required. ";

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var configPath = fso.GetFolder(Server.MapPath(".") + "/../");

	test.details = "Config Path = [" + configPath + "]<p>\n";

	var stride = 3;	//	name, required, note
	var checkFiles = new Array(
		"actions/ado.actions6.asp",				0, "for updating",
		"actions/glerror.asp",					0, "error page for failed actions",
		"actions/custommerchant.actions6.asp",	0, "for CustomMerchant",
		"include/ado.runtime6.asp",				1, "required",
		"include/friends.asp",					1, "required",
		"include/custommerchant.runtime6.asp",	1, "required",
		"include/utils.runtime6.asp",			1, "required",
		"include/xml.runtime6.asp",				1, "required",
		"info/ADODataSourceEditor/Main.html",	0, "for ASP authoring",
		"info/CMDataSourceEditor/Main.html",	0, "for CustomMerchant authoring",// shared
		"info/XMLDataSourceEditor/Main.html",	0, "for XML authoring",			// shared
		"info/ado.info6.asp",					0, "for ASP authoring",
		"info/ado.ui6.xml",						0, "for ASP authoring",
		"info/general.ui6.xml",					0, "for authoring",				// shared
		"info/custommerchant.cart.info6.asp",	0, "for CustomMerchant",
		"info/custommerchant.order.info6.asp",	0, "for CustomMerchant",
		"info/custommerchant.ui6.xml",			0, "for CustomMerchant",			// shared
		"info/custommerchant.xform.info6.xsl",	0, "for CustomMerchant",			// shared
		"info/parseasp.asp",					0, "for ASP authoring",
		"info/reservedwords.ui6.xml",			0, "for ASP authoring",
		"info/test.asp",						0, "for ASP authoring",
		"info/test.html",						0, "for ASP authoring",			// shared
		"info/testsql.asp",						0, "for ASP authoring",
		"info/troubleshooting.asp",				0, "this page",
		"info/ui6.asp",							0, "for ASP authoring",
		"info/vbscript.ui6.xml",				0, "for ASP authoring",
		"info/xml.info6.asp",					0, "for XML authoring",
		"info/xml.ui6.xml",						0, "for XML authoring");		// shared

	var	error = 0;
	var	verify = 0;

	test.details += "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>File</th><th>Exist</th><th>Note</th></tr>\n";
	for (var i = 0; i < checkFiles.length; i += stride) {
		var name     = checkFiles[i];
		var required = checkFiles[i+1];
		var note     = checkFiles[i+2];

		var filePath = configPath + "/" + name;
		test.details += "<tr><td>" + name + "</td>";
		if (fso.FileExists(filePath)) {
			test.details += "<td>Found</td>\n";
		} else {
			if (required) {
				test.details += "<td><span class=\"failed\">Not Found</span></td>\n";
				error++;
			} else {
				test.details += "<td><span class=\"verify\">Not Found</span></td>\n";
				verify++;
			}
		}
		test.details += "<td>" + note + "</td></tr>";
	}
	test.details += "</table>\n";
	test.details += "<p>Config files:<br>\n";
	test.details += "<pre>\n";
	test.details += directoryTree(fso.GetFolder(Server.MapPath(".") + "/../"), 0)
	test.details += "</pre>\n";

	var nmiss = error + verify;
	if (error)	{
		test.Fail(nmiss + " file(s) are missing from your config folder.");
	} else {
		if (verify == 0) {
			test.Pass("All server configuration files are present.");
		} else {
			test.Verify(nmiss + " file(s) are missing from your config folder.");
		}
	}
	return test;
}


function checkServerConfigFilesReturnCode()
{
	var test = new Test("Check config file's line endings");

	test.description  = "This test checks whether the GoLive text files have proper line endings. If you upload the config files or other ASP files from a Macintosh using binary upload, ";
	test.description += "ASP may not work properly. You must upload ASP files as text. ";
	test.description += "Also if the file's line ending is not set to Windows, ASP pages may not work. ";
	test.description += "This is set in GoLive under Edit>Web Settings, Global tab, select Windows (CR/LF) from the popup menu. ";

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var filePath = String(fso.GetFolder(Server.MapPath(".") + "/../")) + "/include/friends.asp";
	test.details = "Checking file = [" + filePath + "]<p>\n";
	var	error = 0;

	if (fso.FileExists(filePath)) {
		var ts = fso.OpenTextFile(filePath, 1); // forReading
		var	lineCounter = 0;
		while (!ts.AtEndOfStream) {
			var line = ts.ReadLine();
			lineCounter++;
		}
		ts.Close();
		test.details += lineCounter + " line(s)<p>\n";
		if (lineCounter == 0) {
			test.Fail("The file is empty.");
		} else if (lineCounter == 1) {
			test.Fail("The file has no line breaks. If the page was uploaded from a Mac, make sure it is uploaded as text.");
		} else {
			test.Pass("The file was uploaded correctly.");
		}
	} else {
		test.details += "config/include/friends.asp was not found<br>\n";
		test.Fail("Server configuration files have not been uploaded properly.");
		error++;
	}
	return test;
}


function checkServerConfigFriendsFile()
{
	var test = new Test("Check config/include/friends.asp file");

	test.description  = "This test checks the friends.asp file, which is used to provide IP based security. By default, access to the GoLive Dynamic Content authoring features is only allowed from the machine on which the server is running ('localhost'). ";
	test.description += "To allow access from machines you need must edit the config/include/friends.asp file to include the IP address of that machine or use the Dynamic Content setup wizard from the Site>Settings>Dynamic Content dialog. ";

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var filePath = String(fso.GetFolder(Server.MapPath(".") + "/../")) + "/include/friends.asp";

	test.details = "Checking file = [" + filePath + "]<p>\n";

	var	error = 0;
	var	checker = 0;

	if (fso.FileExists(filePath)) {
		var ts = fso.OpenTextFile(filePath, 1); // forReading
		var lines = GL_FileFromTextStream(ts);
		ts.Close();
		test.details += "<table border=\"1\" cellpadding=\"4\"><tr><th>IP address</th><th>Mask</th><th>Note</th></tr>\n";
		for (var lnum = 0; lnum < lines.length; ++lnum) {
			var line = lines[lnum];
			if ((line.length == 0)||(line.charAt(0) == ";")||(line.charAt(0) == "<")) {
				continue;
			}
			var splitline = line.split(/\s/);
			var addr = splitline[0].split(".");
			var mask = (splitline.length > 1) ? splitline[1].split(".") : new Array(255, 255, 255, 255);
			test.details += "<tr><td>" + addr[0] + "." + addr[1] + "." + addr[2] + "." + addr[3] + "</td><td>" + mask[0] + "." + mask[1] + "." + mask[2] + "." + mask[3] + "</td><td>\n";

			if ((addr[0] == 127)&&(addr[1] ==	  0)&&(addr[2] ==	  0)&&(addr[3] ==	  1)&&
			   (mask[0] == 255)&&(mask[1] == 255)&&(mask[2] == 255)&&(mask[3] == 255)) {
				test.details += "This is the default setting.\n";
				if (checker == 0) {
					checker = 1;		// default setting
				}
			}else if ((addr[0] == 0)&&(addr[1] == 0)&&(addr[2] == 0)&&(addr[3] == 0)&&
					 (mask[0] == 0)&&(mask[1] == 0)&&(mask[2] == 0)&&(mask[3] == 0)) {
				test.details += "This will disable all security.\n";
				checker = 2; // disable all security
			}else if ((255 < addr[0])||(255 < addr[1])||(255 < addr[2])||(255 < addr[3])||
					 (255 < mask[0])||(255 < mask[1])||(255 < mask[2])||(255 < mask[3])||
					 (0 > addr[0])||(0 > addr[1])||(0 > addr[2])||(0 > addr[3])||
					 (0 > mask[0])||(0 > mask[1])||(0 > mask[2])||(0 > mask[3])) {
				test.details += "This is an invalid setting. Each section of IP address and mask must be between 0 and 255.\n";
				checker = 4; // invalid setting
			} else {
				test.details += "Other settings<br>\n";
				if (checker != 2) {
					checker = 3;
				}
			}
			test.details += "</td></tr>\n";
		}

		test.details += "</table>\n";
		switch(checker) {
			case 0:
				test.Fail("The friends.asp file contains no IP addresses for access.");
				break;
			case 1:
				test.Verify("The friends.asp file is the same as default install. It will only allow access to the local host. ");
				break;
			case 2:
				test.Verify("The friends.asp file is set as \"disable all security\". ");
				break;
			case 3:
				test.Pass("Server configuration is done.");
				break;
			default:
				test.Fail("Server configuration files are not set properly.");
				break;
		}
	} else {
		test.details += "config/include/friends.asp was not found<br>\n";
		test.Fail("Server configuration files were not uploaded properly.");
		error++;
	}
	return test;
}


function checkServerConfigWritePrivilege()
{
	var test = new Test("Check config/include folder write permission");

	test.description  = "This test checks the write permission of config/include folder, which is used by GoLive's Preview function. ";
	test.description += "To preview a dynamic page, GoLive uploads a temporary file to config/include folder so that the web server can process it. ";
	test.description += "If the folder does not have write permission, the preview will not work. ";
	test.description += "Note that you may want to disable write permission on your production servers. ";
	test.description += "In that case, you will not be able to use the GoLive preview with the public server as your site URL. ";
	test.description += "Other features will not be effected. ";
	test.description += "<p>If error 'ASP 0177 : 800a0046' is returned when previewing a page in GoLive, the folder does not have write permission set. ";

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var filePath = fso.GetFileName(Server.MapPath(".") + "../include/writingtest.txt");

	test.details = "Test file = [" + filePath + "]<p>\n";
	var	error = 0;
	var	checker = 0;

	if (fso.FileExists(filePath)) {
		error = -1;
	} else {
		if (!testWriteFileOnServer(fso, filePath)) {
			error++;
			test.details += "<div class=\"failed\">File operation failed to create, write, close, or delete.</div>\n";
		}
	}
	if (error == 0) {
		test.Pass("File writing test was successful.");
	} else if (error == -1) {
		test.Fail("The test filename already exists.");
	} else {
		test.Fail("File writing test failed.");
	}

	return test;
}


function checkServerXMLFileFormat()
{
	var test = new Test("Check XML files");

	test.description  = "This test performs a basic syntax check on the XML files in config/info folder. ";

	if (!testXmlDomSupport()) {
		test.Fail("Since XML DOM is not supported, this test did not performed.");
		return test;
	}

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var folder = fso.GetFolder(server.mapPath(".") + "/../info");
	var	error = 0;

	var folderContents = new Enumerator(folder.files);

	test.details = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>XML File</th><th>Package Version</th><th>Check</th></tr>\n";

	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");

	for (; !folderContents.atEnd(); folderContents.moveNext()) {
		var file = folderContents.item();
		if (file.Name.match(/(.*)\.ui(\d+)\.xml/)) {
			var packageName = RegExp.$1;
			var packageVersion = Number(RegExp.$2);
			if (packageVersion > 100) {
				packageVersion /= 100;
			} else if (packageVersion > 10) {
				packageVersion /= 10;
			}

			if (packageVersion > 6.0) {
				continue;
			}
		} else {
			continue;
		}
		test.details += "<tr><td>" + file.name + "</td><td>" + packageVersion + "</td><td>\n";

		var url = Server.MapPath(".") + "/" + file.name;
		var didLoad = xmlDoc.load(url);
		var errObj = xmlDoc.parseError;
		if (errObj.errorCode == 0) {
			test.details += "<span class=\"passed\">OK</span>";
		} else {
			test.details += "<span class=\"failed\">XML parsing error at line " + errObj.line + ".<br>\n";
			test.details += errObj.reason + "</span>";
			error++;
		}
		test.details += "</td></tr>\n";

	}
	test.details += "</table>\n";

	if (error == 0)	{
		test.Pass("All XML files appear to be fine.");
	} else {
		test.Fail("One or more XML file(s) have problem(s).");
	}

	return test;
}


function checkServerDatabaseDSN()
{
	var test = new Test("Check database datasource files");

	test.description  = "This test examines all the database datasource files found in the datasources folder and produces detailed information about each one. ";
	test.description += "MS-Access (*.mdb) files should not be read-only. ";
	test.description += "If they are read-only any update or other datasource modification action will fail. ";
	test.description += "If MDB files failed to open a connection, the server may have old MDAC version. ";
	test.description += "MDAC 1.5 is installed by default with IIS 4.0, but GoLive requires MDAC 2.1 or later. ";
	test.description += "You can get updater from Microsoft website (<a target=\"_blank\" ";
	test.description += "href=\"http://www.microsoft.com/data/\">http://www.microsoft.com/data/</a>). ";
	test.description += "If UDL, DSN or XDB files failed to open a connection, these files have incorrect settings or the datasource is unavailable. ";
	test.description += "If OpenSchema fails and the other tests are OK, the local server's ASP engine may not support the OpenSchema() call. ";
	test.description += "In this case, the server will not work as a development server with GoLive. ";

	if (!testXmlDomSupport()) {
		test.Fail("Since XML DOM is not supported, this test was not performed.");
		return test;
	}

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var folder = fso.GetFolder(server.mapPath(".") + "/../datasources");
	var	error = 0;

	var folderContents = new Enumerator(folder.files);

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>File</th><th>Attributes / Permission</th><th>Connection</th><th>OpenSchema</th><th>Tables/Fields</th></tr>\n";

	for (; !folderContents.atEnd(); folderContents.moveNext()) {
		var file = folderContents.item();
		test.details += "<tr><td>" + file.name + "</td>";
		test.details += "<td>\n";
		test.details += fileAttributes(file);

		switch(fso.GetExtensionName(file).toUpperCase()) {
			case "MDB":
				if (file.attributes & FileAttrReadOnly) {
					test.details += "<font color=\"red\"><b>Read-Only</b></font><br>\n";
					error++;
					break;
				}
				try {
					var ts = fso.OpenTextFile(file, 8); // forAppending
					ts.close();
					test.details += "ASP has write permission.<br>\n";
				} catch (e) {
					test.details += "<font color=\"red\"><b>ASP does not have write permission to this file.</b></font><br>\n";
					error++;
				}
				break;
			case "DSN":
			case "UDL":
			case "XDB":
			case "ECP":
			case "XDS":
				if (file.attributes & FileAttrReadOnly) {
					test.details += "Read-Only<br>\n";
				}
				try {
					var ts = fso.OpenTextFile(file, 1); // forReading
					ts.close();
					test.details += "ASP has read permission.<br>\n";
				} catch (e) {
					test.details += "<font color=\"red\"><b>ASP does not have read permission to this file.</b></font><br>\n";
					error++;
				}
				break;
		}

		test.details += "</td><td>\n";
		var	connectString = "";

		switch(fso.GetExtensionName(file).toUpperCase()) {
			case "MDB":
				test.details += "MDB<br>\n";
//				connectString = "DRIVER=Microsoft Access Driver (*.mdb);DBQ=" + fso.GetAbsolutePathName(file);	//	ODBC driver
				connectString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + fso.GetAbsolutePathName(file);//	OLE DB driver
				break;
			case "DSN":
				test.details += "DSN<br>\n";
				connectString = "FILEDSN=" + fso.GetAbsolutePathName(file);
				break;
			case "UDL":
				test.details += "UDL<br>\n";
				connectString = "File Name=" + fso.GetAbsolutePathName(file);
			    test.details += connectString + "<br>\n";
				break;
			case "XDB":
				test.details += "XDB<br>\n";
				connectString = "DSN=" + fso.GetBaseName(file);
				break;
			case "ECP":
				test.details += "ECP<br>\n";
				test.details += "CustomMerchant file\n";
				break;
			case "XDS":
				test.details += "XDS<br>\n";
				test.details += "XML datasource file\n";
				break;
			default:
				test.details += "unsupported\n";
				break;
		}
		if ("" == connectString) {
			continue;
		}
		var connection = new ActiveXObject("ADODB.Connection");

		if (!testConnectionOpen(connection, connectString)) {
			test.details += "<span class=\"failed\">Failed</span><br>\n";
			var err = new ActiveXObject("ADODB.Error");
			test.details += "ADO.Error " + connection.Errors.Count + " error(s)<br>\n";
			test.details += "<table border=\"1\">\n";
			for (var i = 0; i < connection.Errors.Count; i++) {
				err = connection.Errors(i);
				test.details += "<tr><td>error[" + i + "]</td><td>Number</td><td>"      + err.Number + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>Source</td><td>"      + err.Source + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>Description</td><td>" + err.Description + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>HelpFile</td><td>"    + err.HelpFile + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>HelpContext</td><td>" + err.HelpContext + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>SQLState</td><td>"    + err.SQLState + "</td></tr>\n";
				test.details += "<tr><td>error[" + i + "]</td><td>NativeError</td><td>" + err.NativeError + "</td></tr>\n";
			}
			test.details += "</table>\n";
			test.details += "</td><td></td><td></td></tr>\n";
			error++;
			continue;
		}
		test.details += "Success";
		test.details += "</td><td>\n";

		var result = testOpenSchema(connection);
		if (result == "") {
			test.details += "<span class=\"failed\">Failed</span></td><td>";
			error++;
		} else {
			test.details += result;
		}
		connection.Close();
		test.details += "</td></tr>\n";
	}
	test.details += "</table>\n";

	if (error == 0) {
		if (noPrimaryKey == 0) {
			test.Pass("All datasource files were found and examined.");
		} else {
			test.Verify("Some tables do not have primary key field.");
		}
	}else	test.Fail("Problem(s) were found with one or more datasource file(s), or OpenSchema() is not supported.");

	return test;
}


function checkServerCustomMerchantDSN()
{
	var test = new Test("Check CustomMerchant datasource files");

	test.description  = "This test examines CustomMerchant datasource files ";
	test.description += "(*.ecp) found in the datasources folder and produces ";
	test.description += "detailed information about each one. ";

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var folder = fso.GetFolder(server.mapPath(".") + "/../datasources");
	var	error = 0;
	var counterEcp = 0;
	var errStr = "<span class=\"Failed\">ERROR</span><br>\n";
	var folderContents = new Enumerator(folder.files);


	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>File</th><th>Attributes</th><th>Setting</th></tr>\n";


	for (; !folderContents.atEnd(); folderContents.moveNext()) {
		var file = folderContents.item();
		test.details += "<tr><td>" + file.name + "</td>";
		test.details += "<td>" + fileAttributes(file) + "</td><td>\n";
		switch(fso.GetExtensionName(file).toUpperCase()) {
			case "ECP":
				counterEcp++;
				var ts = fso.OpenTextFile(file, 1); // forReading
				var lines = GL_FileFromTextStream(ts);
				ts.Close();
				var counterUrl = 0;
				var counterMID = 0;
				for (var i = 0; i < lines.length; i++){
					var line = lines[i];
					if ((line.length == 0)||(line.charAt(0) == ";")) {
						continue;
					}
					var splitline = line.split(/\s/);
					var param = splitline[0];
					var value = splitline[1];
					switch (param) {
						case "url":
							counterUrl++;
							test.details += "url: <a target=\"_blank\" href=\"" + value + "\">" + value + "</a><br>\n";
							if (value == "") {
								test.details += errStr + "\"url\" value is not set.<br>\n";
								error++;
							} else {
								test.details += "<span class=\"Verify\">Verify the URL</span><br>\n";
							}
							break;
						case "merchant-id":
							counterMID++;
							test.details += "merchant-id: " + value + "<br>\n";
							if (value == "") {
								test.details += errStr + "\"merchant-id\" value is not set.<br>\n";
								error++;
							}
							break;
						default:
							break;
					}
				}
				if (counterUrl == 0) {
					test.details += errStr + "\"url\" setting is not in the file.<br>\n";
					error++;
				}
				if (counterUrl > 1) {
					test.details += errStr + "There are multiple \"url\" settings in the file.<br>\n";
					error++;
				}
				if (counterMID == 0) {
					test.details += errStr + "\"merchant-id\" setting is not in the file.<br>\n";
					error++;
				}
				if (counterMID > 1) {
					test.details += errStr + "There are multiple \"merchant-id\" settings in the file.<br>\n";
					error++;
				}
				break;
			case "MDB":
			case "DSN":
			case "UDL":
			case "XDB":
				test.details += "Database datasource file.<br>\n";
				break;
			case "XDS":
				test.details += "XML datasource file\n";
				break;
			default:
				break;
		}
		test.details += "</td></tr>\n";
	}
	test.details += "</table>\n";

	if (error == 0) {
		if (counterEcp == 0) {
			test.Verify("No CustomMerchant datasource (*.ecp) files found in datasources folder.");
		} else {
			test.Verify("Verify url setting on the each hyperlink.");
		}
	} else {
		test.Fail("Problem(s) were found with one or more datasource file(s).");
	}
	return test;
}


function checkServerXMLDSN()
{
	var test = new Test("Check XML datasource files");

	test.description  = "This test examines XML datasource files ";
	test.description += "(*.xds) found in the datasources folder and produces ";
	test.description += "detailed information about each one. ";

	if (!testXmlDomSupport()) {
		test.Fail("Since XML DOM is not supported, this test did not performed.");
		return test;
	}

	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var folder = fso.GetFolder(server.mapPath(".") + "/../datasources");
	var	error = 0;
	var counterXds = 0;
	var errStr = "<span class=\"Failed\">ERROR</span><br>\n";
	var folderContents = new Enumerator(folder.files);

	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>File</th><th>Attributes</th><th>Setting</th></tr>\n";

	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async = false;

	for (; !folderContents.atEnd(); folderContents.moveNext()) {
		var file = folderContents.item();
		test.details += "<tr><td>" + file.name + "</td>";
		test.details += "<td>" + fileAttributes(file) + "</td><td>\n";
		switch(fso.GetExtensionName(file).toUpperCase()) {
			case "XDS":
				counterXds++;
				var didLoad = xmlDoc.load(file.Path);
				var errObj = xmlDoc.parseError;
				if (errObj.errorCode != 0) {
					test.details += "<span class=\"failed\">XML parsing error at line " + errObj.line + ".<br>\n";
					test.details += errObj.reason + "</span>";
					error++;
					break;
				}
				var nodeName = xmlDoc.documentElement.nodeName;
				test.details += "Node name: " + nodeName + "<br>\n";
				if (String(nodeName).indexOf("GL6XMLSOURCE") == -1) {
					test.details += "<span class=\"failed\">It is not GoLive 6 XML Datasource format.</span><br>\n";
					error++;
					break;
				}
				var counterXslurl = 0;
				var counterXmlurl = 0;
				var counterMID = 0;
				for (var i = 0; i < xmlDoc.documentElement.attributes.length; i++) {
					var attribute = xmlDoc.documentElement.attributes.item(i);
					var name  = attribute.nodeName;
					var value = attribute.nodeValue;
					switch (name) {
						case "xslurl":
							counterXslurl++;
							test.details += "Attribute [" + name + "] : " + value + "<br>\n";
							break;
						case "xmlurl":
							counterXmlurl++;
							test.details += "Attribute [" + name + "] : <a target=\"_blank\" href=\""
							+ value + "\">" + value + "</a><br>\n";
							var xmlurl = new ActiveXObject("Microsoft.XMLDOM");
							xmlurl.async = false;
							var errObj = xmlurl.parseError;
							if (errObj.errorCode != 0) {
								test.details += "<span class=\"failed\">XML parsing error at line " + errObj.line + ".<br>\n";
								test.details += errObj.reason + "</span>";
								error++;
							}
							break;
						default:
							test.details += "Attribute [" + name + "] : " + value + "<br>\n";
							break;
					}
				}
				if (counterXslurl == 0) {
					test.details += errStr + "Attribute [xslurl] setting is not in the file.<br>\n";
					error++;
				}
				if (counterXmlurl == 0) {
					test.details += errStr + "Attribute [xmlurl] setting is not in the file.<br>\n";
					error++;
				}
				break;
			case "MDB":
			case "DSN":
			case "UDL":
			case "XDB":
				test.details += "Database datasource file.<br>\n";
				break;
			default:
				break;
		}
		test.details += "</td></tr>\n";
	}
	test.details += "</table>\n";

	if (error == 0) {
		if (counterXds == 0) {
			test.Verify("No XML datasource file (*.xds) found in datasources folder.");
		} else {
			test.Verify("Verify url setting on the each hyperlink.");
		}
	} else {
		test.Fail("Problem(s) were found with one or more datasource file(s).");
	}
	return test;
}


function checkServerVariable()
{
	var test = new Test("Check server variables");

	test.description = "This test generates a table of server variables so that you can review and verify their status. ";
	test.details  = "<table border=\"1\" cellpadding=\"4\">\n";
	test.details += "<tr><th>Variable</th><th>Values</th></tr>\n";
	test.details += writeServerVariables();
	test.details += "</table>\n";

	test.Pass("ASP server variables.");

	return test;
}


function checkOther()
{
	var test = new Test("Check other issues");

	test.description  = "If you are still having problems, here's a listing of known issues you can check manually. ";
	test.description += "Some problems may be dependent on web server versions, datasource server, datasource driver. ";

	var title = "";
	var symptom = "";
	var prescription = "";
	test.details = "";

	title = "MDAC (Microsoft Data Access) version";
	symptom = "MDAC version 1.5 will fail to connect with Access 2000 datasources. (MDAC 1.5 is part of the Option Pack for IIS, and is not updated by Windows NT service packs.)";
	prescription = "MDAC 2.1 or later is required for GoLive.  MDAC is installed in [system drive]:\\Program Files\\Common Files\\System\\ado\\ folder. ";
	prescription += "If you have the file ADO210.CHM, the server has MDAC 2.1 installed.";
	prescription += "<p>Windows 2000 installs MDAC version 2.5, which is compatible with GoLive.</p>";
	prescription += "<p>To update MDAC, go to Microsoft web site <a target=\"_blank\" ";
	prescription += "href=\"http://www.microsoft.com/data/\">http://www.microsoft.com/data/</a> ";
	prescription += "or do a search for \"MDAC\".</p>";
	prescription += "Microsoft also offers an MDAC version checker, called \"Component Checker\".</p>";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "Primary Key Field";
	symptom = "When the runtime debug switch is on (you can set the RuntimeDebug flag in config/inlude/utils.runtime6.asp), ";
	symptom += "you may receive an error message \"Runtime Error: No primary key is specified\" when you preview an ASP document.";
	symptom += "You may also experience significant performance degradation without a primary key.";
	prescription = "This may be caused by using an ODBC driver, which does not support automatic detection of primary keys. ";
	prescription += "This may cause incorrect results or behavior when displaying multiple records in a table, or when updating or ";
	prescription += "deleting records using a form.";
	prescription += "<p>You can manually specify the primary key field by editing the ADORecordSet() function call in the ";
	prescription += "document's &lt;head&gt; section. For example, change:";
	prescription += "<dl><dd>set Photos = ADORecordSet(\"album\" , \"select * from Photos\", \"block=0\", \"\", \"Photos\")</dl> to:";
	prescription += "<dl><dd>set Photos = ADORecordSet(\"album\" , \"select * from Photos\", \"block=0\", \"ID\", \"Photos\")</dl>";
	prescription += "or, if more than one field comprises the primary key, enter each separated by commas:";
	prescription += "<dl><dd>set Photos = ADORecordSet(\"album\" , \"select * from Photos\", \"block=0\", \"ID,SKU\", \"Photos\")</dl>";
	prescription += "If you are using the OLE DB driver for your datasource (which is recommended), you do not have to edit ";
	prescription += "this function call: GoLive will automatically add the correct primary key field(s).";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "POST versus GET";
	symptom = "You get unexpected results or errors when you update records or link to detail pages.";
	prescription = "If you have a form in an ASP document, you should use POST rather than GET to avoid problems ";
	prescription += "with the limits inherent to the GET method.  GoLive should automatically set the form ";
	prescription += "method to POST.  Check in the inspector palette with the form selected.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "HTML Tags in DataSources Records";
	symptom = "&lt;TEXTAREA&gt; tag breaks layout";
	prescription = "If records in your datasource include strings that might be interpreted as HTML tags (for example, ";
	prescription += "\"&lt;/textarea&gt;\") HTML rendering may fail.  To avoid this problem, set the field's filter ";
	prescription += "to \"Encode String as HTML\" in the Binding Details section of the Dynamic Content palette.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "ODBC driver from Oracle or Microsoft";
	symptom = "Dynamic page with Oracle datasource shows unexpected data.";
	prescription = "If you need to use an ODBC driver with Oracle (OLE DB is preferred, for reasons described earlier), ";
	prescription += "you should use the Microsoft ODBC driver (named \"Microsoft ODBC for Oracle\") rather than the Oracle ";
	prescription += "ODBC driver (\"Oracle ODBC Driver\").";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "FileMaker Pro 5 for ODBC";
	symptom = "<br>* Table and field names do not appear in the Dynamic Content palette.";
	symptom += "<br>* Previewing or running ASP pages results in runtime errors.";
	prescription = "To configure FileMaker Pro 5 for use with GoLive, make sure that:";
	prescription += "<br>* FileMaker Pro 5 is running with your datasource open,";
	prescription += "<br>* the datasource is set as shared,";
	prescription += "<br>* the \"Remote Data Access Companion\" option (File &gt; Sharing &gt; Remote Data Access Companion) is enabled,";
	prescription += "<br>* the \"Use Remote Connection\" option in the ODBC data source control panel is enabled,";
	prescription += "<br>* the \"Server Address\" field of the ODBC control panel contains the IP address of the machine running FileMaker Pro.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "Virtual root setting.";
	symptom = "<br>* Browser shows 404 error.";
	symptom += "<br>* Updating record goes to the wrong URL.";
	prescription = "You should use the same path name on both your staging server and production server. ";
	prescription += "For example, if you develop ASP pages on your computer using a content source of ";
	prescription += "http://localhost/golive_vbs/, your production server virtual root path should be /golive_vbs/ also.";
	prescription += "The host name may be (and generally, will be) different; this will not affect your ASP documents.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "config/info folder";
	symptom = "Potential security hole";
	prescription = "The files in the \"info\" folder (config/info/*.*) are used by GoLive to create ";
	prescription += "ASP documents, but are not needed when you deploy your finished pages.  You should not install ";
	prescription += "the config/info files on your production server because of the potential for security problems.<p>";
	prescription += "You may wish to install these files temporarily to verify your production server's environment ";
	prescription += "using this troubleshooting.asp document, but should remove them after completing the tests. ";
	prescription += "Check the GoLive User Guide for more information on site security.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "config/datasources folder";
	symptom = "Potential security hole";
	prescription = "The config/datasources folder contains datasource files, or UDL files ";
	prescription += "contains datasource information, possibly including ID/password information.<p>";
	prescription += "To prevent unauthorized access to your datasource files, you should disallow \"Read\", \"Write\" ";
	prescription += "and \"Directory browsing\" permissions under IIS to the config/datasources folder.<p>";
	prescription += "For increased security, you can move the config/datasources folder out of the virtual root. ";
	prescription += "In this case, you will need to edit GetDataSourcePath() function in config/include/utils.runtime6.asp file.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	title = "FTP file setting";
	symptom = "Possible GoLive misconfiguration";
	prescription = "ASP files need to be transferred using FTP/WebDAV as text files. ";
	prescription += "If it is not set properly, it will likely cause server error messages.";
	prescription += "Check GoLive Edit->Web Settings->File Mappings for ASP file setting.";
	checkOtherSubAddToTestDetails(test, title, symptom, prescription);

	test.Verify("Check these issues manually.");

	return test;
}

//--- Utility Functions -------------------------------------------------------
// These are used by the test functions.
// ----------------------------------------------------------------------------

// Recursively build an ASCII representation of a directory tree
function directoryTree(folder, level)
{
	var msg = "";
	var files = new Enumerator(folder.files);
	for (; !files.atEnd(); files.moveNext()) {
		for (var i = 0; i < level; i++) {
			msg += "|   ";
		}
		msg += "    ";
		msg += files.item().Name + "\n";
	}
	var subfolders = new Enumerator(folder.SubFolders);
	for (; !subfolders.atEnd(); subfolders.moveNext()) {
		for (var i = 0; i < level; i++) {
			msg += "+---";
		}
		msg += "+---";
		msg += subfolders.item().Name + "\n";
		msg += directoryTree(subfolders.item(), level+1);
	}
	return msg;
}


function listDataSourcesField(connection, tableName)
{
	var msg = "";
	var catalog = new ActiveXObject("ADOX.Catalog");
	var index	= new ActiveXObject("ADOX.Index");
	var table	= new ActiveXObject("ADOX.Table");
	var column	= new ActiveXObject("ADOX.Column");
	var column2 = new ActiveXObject("ADOX.Column");
	var	primaryKeyCounter = 0;
	var	indexColumnsSupport = true;

	catalog.ActiveConnection = connection;
	table = catalog.Tables.Item(String(tableName));
	if (table.Type == "TABLE") {	// only usr table, skip system table

		// Check the table name for problems
		msg += CheckName(tableName);

		for (var j = 0; j < table.Columns.Count; j++) {
			column = table.Columns.Item(j);
			msg += "<dd>" + column.Name + "\n";
			msg += CheckName(column.Name);
			for (var k = 0; k < table.Indexes.Count; k++) {
				index = table.Indexes.Item(k);
				if (!index.PrimaryKey) {
					continue;	//	skip non-primary key
				}
				if (testIndexColumns(index)) {	// supported
					for (var m = 0; m < index.Columns.Count; m++) {
						column2 = index.Columns.Item(m);
						if (column2.Name == column.Name) {
							msg += "<b>(primary key)</b>\n";
							primaryKeyCounter++;
							break;	// to avoid duplicated
						}
					}
				} else {	//	not supported
					indexColumnsSupport = false;
				}
			}
		}
	}
	if (indexColumnsSupport) {
		if (primaryKeyCounter == 0) {
			msg += "<br><span class=\"verify\">This table does not have a primary key field.</span>\n";
			noPrimaryKey++;
		}
	} else {
		msg += "<br><span class=\"verify\">Unable to discover primary key field automatically, because ODBC drivers do not support this feature.</span>\n";
		noPrimaryKey++;
	}
	return msg;
}


//---------------------------------------------------------------
// Constructor for an object that represents a set of reserved
// words. Usage:
//  	var reserved = new ReservedWords();
//		if (reserved.IsReservedWord("foo")) ...
//---------------------------------------------------------------
function ReservedWords()
{
	// define instance variables and methods for objects
	this.reservedList = new Object;

	var xml = new ActiveXObject("Microsoft.XMLDOM");
	xml.async = false;
	var url = Server.MapPath(".") + "/sreservedwords.ui6.xml";
	var didLoad = xml.load(url);
	if (didLoad) {
		var headElement = xml.documentElement;

		for (var i = 0; i < headElement.childNodes.length; ++i) {
			this.reservedList[headElement.childNodes[i].text] = true;
		}
	}	// ELSE: ERROR! What to do? What to do?...
}


// Method for ReservedWords class
function is_reserved(theWord)
{
	return (this.reservedList[theWord.toUpperCase()] == true);
}


ReservedWords.prototype.IsReserved = is_reserved;


//---------------------------------------------------------------
// Test the passed name to see whether it violates one or more
// of the following conditions:
// (1) one or more spaces in the name
// (2) begins with string "NAMES..."
// (3) a leading '~' character
// (4) a reserved word.
//
// Returns: a string with any error conditions found.
//---------------------------------------------------------------


var sReservedWords = null;	// a singleton object used by CheckName

function CheckName(theName)
{
	var s = new String(theName);

	s = s.toUpperCase(s);

	if (sReservedWords == null) {
		sReservedWords = new ReservedWords();
	}

	var result = "";

	if (s.indexOf(" ") >= 0) {
		result += " Name should not contain spaces!";
	}

	if (s.indexOf("NAMES") == 0) {
		result += " Name should not begin with \"NAMES\"!";
	}

	if (s.charAt(0) == "~") {
		result += " Name should not have a leading tilde (\"~\") character!";
	}

	if (sReservedWords.IsReserved(s) == true) {
		result += " Name should not be an ODBC reserved word!";
	}

	if (result != "") {
		result = "<span class=\"failed\"> Warning:" + result + "</span>";
	}
	return result;
}

//---------------------------------------------------------------
// Check file attributes and return the string
//---------------------------------------------------------------
function fileAttributes( file )
{
	var msg = "";
	if (file.attributes & FileAttrDirectory	) {
		msg += "Directory<br>\n";
	}
	if (file.attributes & FileAttrHidden	) {
		msg += "Hidden<br>\n";
	}
	if (file.attributes & FileAttrSystem	) {
		msg += "System<br>\n";
	}
	if (file.attributes & FileAttrVolume	) {
		msg += "Volume<br>\n";
	}
	if (file.attributes & FileAttrArchive	) {
		msg += "Archive<br>\n";
	}
	if (file.attributes & FileAttrAlias		) {
		msg += "Alias<br>\n";
	}
	if (file.attributes & FileAttrCompressed) {
		msg += "Compressed<br>\n";
	}
	return msg;
}




// Top level function that invokes and displays the tests.
function main()
{
	Response.Write(htmlHeader());

	var msg = "";
	msg += "<h1>Adobe GoLive (ASP) Troubleshooting Report</h1>\n";
	msg += "<p>This report contains information about the status of your ASP server software and the Adobe GoLive files installed on the server.\n";
	msg += "Below you will find the results of various tests performed by this troubleshooting script.</p>\n";
	msg += "<p>Please refer to the GoLive User Guide and 'readme' file for more information about installing and configuring your ASP server to work with Adobe GoLive.</p>\n";

	msg += "<p>Click here for some <a href=\"troubleshooting2.asp\">additional troubleshooting tools</a>.  These tools scan your entire site for dynamic content specific errors in pages.</p>";
	msg += "<p>Click here to run <a href=\"testsql.asp\">test queries directly to databases</a>.</p>\n";
	Response.Write(msg);

	if (precheck() == 0) {
		var	TestResults = new Array();
		// perform each test and store resulting Test objects in TestResults
		var check = 0;
		TestResults[check++] = checkASPSoftware();
		TestResults[check++] = checkServerVersion();
		TestResults[check++] = checkScriptEngineVersion();
		TestResults[check++] = checkMsXmlVersion();
		TestResults[check++] = checkXmlDomSupport();
		TestResults[check++] = checkVirtualPathSetting();
		TestResults[check++] = checkSessionStateSetting();
		TestResults[check++] = checkPasswordSetting();
		TestResults[check++] = checkServerConfigFiles();
		TestResults[check++] = checkServerConfigFilesReturnCode();
		TestResults[check++] = checkServerConfigFriendsFile();
		TestResults[check++] = checkServerConfigWritePrivilege();
		TestResults[check++] = checkServerXMLFileFormat();
		TestResults[check++] = checkServerDatabaseDSN();
		TestResults[check++] = checkServerCustomMerchantDSN();
		TestResults[check++] = checkServerXMLDSN();
		TestResults[check++] = checkServerVariable();
		TestResults[check++] = checkOther();

		// write out the test summary, followed by the individual test details
		Response.Write(reportSummary(TestResults));
		Response.Write(reportDetail(TestResults));
	}
	Response.Write(htmlFooter());
	return 0;
}

</script>

