<%@Language="VBScript"%>
<%Option Explicit%>
<!-- #INCLUDE FILE="troubleshootinginclude.asp" -->

<%
Response.ContentType = "text/html"
Response.CharSet = "windows-" & Session.CodePage
on error resume next

' --- troubleshooting.asp -----------------------------------------------------
' ADOBE SYSTEMS INCORPORATED
' Copyright 2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
' License Agreement, Adobe permits you to reproduce and distribute this 
' file only as an integrated part of a web site created with Adobe 
' GoLive software and only for the purpose of enabling your client to 
' display their web site. All other terms of the Adobe license 
' agreement remain in effect.
'
' Adobe GoLive (ASP) Troubleshooting Report
'
' This Active Server Page file performs a series of tests to verify that
' the Adobe GoLive server files are properly installed and configured.
'
' IMPORTANT: This file is for troubleshooting purposes only.  You should not
' leave this file installed on a production server because it might provide
' users with information about your security setup and the structure of your
' datasource files.
' -----------------------------------------------------------------------------

' -----------------------------------------------------------------------------
' Call the main function, written in JScript, below.

main()

%>

<script runat="server" language="JScript">

// --- Test Creation Functions ------------------------------------------------
// These functions create a new Test object, perform a test, and return the
// Test object with the results.
// ----------------------------------------------------------------------------


function checkOutputFiles()
{
	var test = new Test("Check output files");
	test.description = "This test checks output server files' syntax.";

	directoryScanError = 0;	// reset
	var fso = Server.CreateObject("Scripting.FileSystemObject");
	test.details += directoryScan(fso.GetFolder(Server.MapPath(".") + "/../../"), 0)

	if (directoryScanError == 0)	{
		test.Pass("Output files seem to be fine.");
	} else {
		test.Fail("Problem(s) found in " + directoryScanError + " file(s).");
	}
	return test;
}


//--- Utility Functions -------------------------------------------------------
// These are used by the test functions.
// ----------------------------------------------------------------------------

// Recursively scan output file
function directoryScan(folder, level)
{
	var stride = 2;	//	string, error message
	var checkStr = new Array(
		"Empty_Content_Source",	"Content source is not set properly.",
		"Empty_Field",			"Field is not set properly.",
		"EMPTY_VALUE",			"Empty value."
	);

	var msg = "";
	msg += "<p>" + folder + "<br>\n";

	var files = new Enumerator(folder.files);
	var fso = Server.CreateObject("Scripting.FileSystemObject");
	msg += "<table border=\"1\" cellpadding=\"4\">\n";
	msg += "<tr><th>Filename</th><th>Scan Result</th><th>Lines</th></tr>\n";
	for (; !files.atEnd(); files.moveNext()) {
		if (String(files.item().Name).toLowerCase().indexOf(".asp") == -1) {
			continue;
		}
		msg += "<tr><td>" + files.item().Name + "</td><td>";
		var ts = fso.OpenTextFile(files.item().Path, 1); // forReading
		var lines = GL_FileFromTextStream(ts);
		ts.Close();
		var	lineCounter = 0;
		var	errorOnFile = 0;
		for (lineCounter = 0; lineCounter < lines.length;) {
			var content = lines[lineCounter++];
			if (content.indexOf("!-- Mock Content") != -1) {
				break;	// do not check mock content area
			}
			for (var i = 0; i < checkStr.length; i += stride) {
				var str    = checkStr[i];
				var errMsg = checkStr[i+1];
				if (content.indexOf(str) != -1) {
					msg += "<span class=\"failed\">"+ str + " found at line #" + lineCounter + "</span><br>\n";
					msg += errMsg + "<br>\n";
					errorOnFile++;
				}
			}
		}
		if (errorOnFile == 0) {
			msg += "<span class=\"passed\">OK</span><br>\n";
		} else {
			directoryScanError++;
		}
		msg += "</td><td align=\"right\">" + lineCounter + " line(s)<br>\n";
		msg += "</td></tr>";
	}
	msg += "</table>\n";
	var subfolders = new Enumerator(folder.SubFolders);
	for (; !subfolders.atEnd(); subfolders.moveNext()) {
		if (String(subfolders.item().Name).toLowerCase().indexOf("config") != -1) {
			continue;
		}
		msg += directoryScan(subfolders.item(), level+1);
	}
	return msg;
}


// Top level function that invokes and displays the tests.
function main()
{
	Response.Write(htmlHeader());

	var msg = "";
	msg += "<h1>Adobe GoLive (ASP) Troubleshooting Report</h1>\n";
	msg += "<p>This report contains information about the status of your ASP server software and the Adobe GoLive files installed on the server.\n";
	msg += "Below you will find the results of various tests performed by this troubleshooting script.</p>\n";
	msg += "<p>Click here to run <a href=\"testsql.asp\">test queries directly to databases</a>.</p>\n";
	msg += "<p><a href=\"troubleshooting.asp\">Main Troubleshooting Page</a></p>\n";
	Response.Write(msg);

	if (precheck() == 0) {
		var	TestResults = new Array();
		// perform each test and store resulting Test objects in TestResults
		var check = 0;
		TestResults[check++] = checkOutputFiles();

		// write out the test summary, followed by the individual test details
		Response.Write(reportSummary(TestResults));
		Response.Write(reportDetail(TestResults));
	}
	Response.Write(htmlFooter());
	return 0;
}

</script>

