<%init_troubleshootinginclude_vbs()%>
<%init_troubleshootinginclude_js()%>

<SCRIPT runat="server" language="VBScript">
' --- troubleshooting.asp -----------------------------------------------------
' ADOBE SYSTEMS INCORPORATED
' Copyright 2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
' License Agreement, Adobe permits you to reproduce and distribute this 
' file only as an integrated part of a web site created with Adobe 
' GoLive software and only for the purpose of enabling your client to 
' display their web site. All other terms of the Adobe license 
' agreement remain in effect.
'
' Adobe GoLive (ASP) Troubleshooting Report
'
' This Active Server Page file performs a series of tests to verify that
' the Adobe GoLive server files are properly installed and configured.
'
' IMPORTANT: This file is for troubleshooting purposes only.  You should not
' leave this file installed on a production server because it might provide
' users with information about your security setup and the structure of your
' datasource files.
' -----------------------------------------------------------------------------

' *****************************************************************************
' Global variables

' -----------------------------------------------------------------------------
' Initialize VBScript part
function init_troubleshootinginclude_vbs()
	Response.Buffer = true
end function

</SCRIPT>

<SCRIPT runat="server" language="JScript">

// *****************************************************************************
// Global variables
var RuntimeDebug;	// DEBUGGING: true or false (default)
var FORMERR_NAME;
var	noPrimaryKey;		// used in checkServerDataSourcesFiles()
var	directoryScanError;	// used in checkOutputFiles()

// file attribute bit fields
var FileAttrNormal;
var FileAttrReadOnly;
var FileAttrHidden;
var FileAttrSystem;
var FileAttrVolume;
var FileAttrDirectory;
var FileAttrArchive;
var FileAttrAlias;
var FileAttrCompressed;


// *****************************************************************************
// Initialize JScript part
function init_troubleshootinginclude_js()
{
	RuntimeDebug = false;	// true or false (default)
	FORMERR_NAME = "FORMERR";
	noPrimaryKey = 0;	
	directoryScanError = 0;	
	FileAttrNormal		= 0;
	FileAttrReadOnly	= 1;
	FileAttrHidden		= 2;
	FileAttrSystem		= 4;
	FileAttrVolume		= 8;
	FileAttrDirectory	= 16;
	FileAttrArchive		= 32;
	FileAttrAlias		= 64;
	FileAttrCompressed	= 128;
	return;
}


function htmlHeader()
{
	var msg = "<html>\n";
	msg += "<head>\n";
	msg += "<meta http-equiv=\"content-type\" content=\"text/html;charset=";
	msg += Session.CodePage + "\">\n";
	msg += "<title>Adobe GoLive (ASP) Troubleshooting Report</title>\n";
	msg += "<link rel=\"stylesheet\" href=\"gl.css\" type=\"text/css\">\n";
	msg += "</head>\n";
	msg += "<body>\n";
	msg += "<a name=\"top\"></a>\n";
	return msg;
}

function htmlFooter()
{
	var msg = "<hr>\n";
	msg += "</body>\n";
	msg += "</html>\n";
	return msg;
}

function reportSummary(TestResults)
{
	var report = "<hr>\n";

	report += "<h2>Test Summary</h2>\n";
	report += "<b>" + TestResults.length + " tests performed.</b><p>";
	report += "<p><table border=\"1\" cellpadding=\"4\">\n";
	report += "<tr><th>Test</th><th>Description</th><th>Results</th><th>Summary</th></tr>\n";
	for (var i = 0; i < TestResults.length; i++) {
		var test = TestResults[i];
		report += "<tr><td align=\"center\">" + (i + 1) + "</td><td><a href=\"#" + (i + 1) + "\">" + test.title + "</a></td><td>";
		report += test.ResultStr() + "</td>";
		report += "<td>" + test.summary + "</td></tr>\n";
	}
	report += "</table>\n";
	report += "<h3>How to read the test results</h3>\n";
	report += Test.ResultStr[0] + ": The test was successful, no further action required.<br>\n";
	report += Test.ResultStr[1] + ": Problem(s) were found. Refer to the test report details for more information.<br>\n";
	report += Test.ResultStr[2] + ": This may or may not be a problem depending on your environment, your should manually verify this information.  Read the report details for instructions.<br>\n";

	return report;
}


function reportDetail(TestResults)
{
	var report = "";

	for (var i = 0; i < TestResults.length; i++) {
		var test = TestResults[i];

		report += "<hr>\n";
		report += "<a name=\"" + (i + 1) + "\"></a>\n";
		report += "<h2> Test " + (i + 1) + ": " + test.title + "</h2>\n";
		report += "<p>" + test.ResultStr() + ": " + test.summary + "</p>\n";
		report += "<p><b>Description: </b>" + test.description + "</p>\n";
		report += test.details;
		report += "<p><a href=\"#top\">Back to Top</a></p>\n";
	}
	return report;
}

/*
 * Read FILENAME into an array of lines and return it.
 * Try to conform to any/all of MacOS (\r) UNIX (\n)
 * and Windows (\r\n) line-ending conventions.
 * The returned lines do not have the line terminator appended;
 * this seems to match the TextStream.ReadLine() method that
 * this function replaces.
 * NB there may be a 0-length last line, an implementation
 * artifact of String.split().
 * NB this is a duplicate of the function in utils.runtime6.asp.
 */
function GL_FileFromTextStream(ts) {
	var content = ts.ReadAll();
	return content.split(/\r\n?|\n/);
}


// --- Test Class -------------------------------------------------------------
// A simple object with instance variables containing the results.
// ----------------------------------------------------------------------------

function Test(title)
{
	this.title			= title;
	this.description	= "";
	this.details		= "";
	this.result			= Test.kPass;
	this.summary		= "";
}

// Test results are one of the following
Test.kPass	 = 0;
Test.kFail	 = 1;
Test.kVerify = 2;

// HTML strings for each test result
Test.ResultStr = new Array(
	"<span class=\"passed\">Passed</span>",
	"<span class=\"failed\">Failed</span>",
	"<span class=\"verify\">Verify</span>");

function test_Pass(summary)
{
	this.result	 = Test.kPass;
	this.summary = summary;
}
Test.prototype.Pass = test_Pass;

function test_Fail(summary)
{
	this.result	 = Test.kFail;
	this.summary = summary;
}
Test.prototype.Fail = test_Fail;

function test_Verify(summary)
{
	this.result	 = Test.kVerify;
	this.summary = summary;
}
Test.prototype.Verify = test_Verify;

function test_ResultStr()
{
	return Test.ResultStr[this.result];
}
Test.prototype.ResultStr = test_ResultStr;


// --- Precheck Function ------------------------------------------------------
// This function check if the troulbleshooting page is in the config/info folder
// ----------------------------------------------------------------------------
function precheck()
{
	var error = 0;
	var pathTranslated = String(Request.ServerVariables("PATH_TRANSLATED"));
    if ((pathTranslated.indexOf("config\\info\\troubleshooting") < 0) &&
        (pathTranslated.indexOf("config/info/troubleshooting")   < 0)) {
		var msg = "<span class=\"failed\">This troubleshooting file need to be under ";
		msg += "config/info folder to work properly. Please relocate and try again.</span>";
		Response.Write(msg);
		error = -1;
	}
	return error;
}


// --- Test Creation Functions ------------------------------------------------
// These functions create a new Test object, perform a test, and return the
// Test object with the results.
// ----------------------------------------------------------------------------


//Note: this function is not used any more.
function checkParentPath()
{
	var test = new Test("Check that \"..\" is allowed");

	test.description  = "This test checks to make sure that GoLive config files can access the \"..\" folder. ";
	test.description += "If the parent folder is not accessible using \"..\" the config files will not work. ";

	if (testParentPath()) {
		var fileSystem = Server.CreateObject("Scripting.FileSystemObject");
		var current = fileSystem.GetFolder(Server.MapPath("."));
		var parent	= fileSystem.GetFolder(Server.MapPath(".") + "/../");

		test.details = "<table border=\"1\" cellpadding=\"4\">\n";
		test.details += "<tr><th>Path</th><th>Value</th></tr>\n";
		test.details += "<tr><td>Current path</td><td>" + current + "</td></tr>\n";
		test.details += "<tr><td>Parent path </td><td>" + parent  + "</td></tr>\n";
		test.details += "</table>\n";

		test.Pass("Parent folder is accessible with \"..\".");
	} else {
		test.Fail("Parent folder is not accessible with \"..\".");
	}
	return test;
}


//--- Utility Functions -------------------------------------------------------
// These are used by the test functions.
// ----------------------------------------------------------------------------

function checkOtherSubAddToTestDetails(test, title, symptom, prescription)
{
	test.details += "<div class=\"manual\">\n";
	test.details += "<span class=\"manualTitle\">" + title + "</span><p>\n";
	test.details += "<span class=\"manualSymptom\"> <b>Symptom: </b>" + symptom + "</span><p>\n";
	test.details += "<span class=\"manualPrescription\"> <b>Prescription: </b>" + prescription + "</span>\n";
	test.details += "</div>\n";
}

</SCRIPT>

