/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.runtime6.jdbc;

class GLPooledConnection
	extends GLConnectionBase
{
	public GLPooledConnection(java.sql.Connection con, GLDataSource ds) {
		this.con = con;
		this.ds = ds;
	}

	public void
	close()
		throws java.sql.SQLException
	{
		log(10, "GLPooledConnection.close {");
		if (!this.closed) {
			this.closed = true;
			if (!this.autoCommit)
				try {
					setAutoCommit(true);
				} catch (java.sql.SQLException e) {}
			ds.returnConnection(this.con);
			this.con = null;
		}
		log(10, "GLPooledConnection.close }");
	}

	public boolean
	isClosed()
		throws java.sql.SQLException
	{
		return closed || con.isClosed();
	}

	public void
	setAutoCommit(boolean b)
		throws java.sql.SQLException
	{
		this.con.setAutoCommit(b);
		this.autoCommit = b;
	}

	private GLDataSource ds;
	private boolean closed;
	private boolean autoCommit = true;
}
