/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.runtime6.utils;

/**
 * Objects that implement ContentSourceWrapper provide stylized
 * access to table-structured data.  Move, MoveToFirst, MoveNext,
 * and MoveTo navigate an internal cursor to a specific table row.
 * AbsolutePosition() returns the cursor value.
 * EOF() is true iff we've gone off the end.
 * The Value() methods get the content of the indicated cell in the
 * current row.
 */
public interface ContentSourceWrapper {
	int AbsolutePosition();
	int BlockSize();
	void Close();
	boolean EOB();
	boolean EOF();
	String Error(String key);
	int FirstRecordOnPage();
	int LastRecordOnPage();
	java.util.Hashtable GetGenerator(boolean allRecords)
		throws GLException;
	String GetName();
	String Key() throws GLException;
	void Move(int delta);
	void MoveFirst();
	void MoveNext();
	void MoveTo(int pos);
	void MoveToKey(java.util.Hashtable key) throws GLException;
	ContentSourceWrapper NestedCSW(String name) throws GLException;
	String[] PrimaryKey();
	int RecordCount();
	Object Value(String key) throws GLException;
	Object Value(int j) throws GLException;
};
