/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.runtime6.utils;

/**
 * Exceptions thrown by GoLive Dynamic Content server-side code.
 */
public class GLException
extends Exception {
	public GLException() {
		super();
	}
	public GLException(String s) {
		super(s);
	}
	/**
	 * ERR is an HTTP error code.
	 */
	public GLException(String s, int err) {
		super(s);
		httperr = err;
	}
	/**
	 * Retrieve the HTTP error code.
	 */
	public int
	getHttpError() {
		return httperr;
	}
	private int httperr = 500;
}
