/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.servlets6.dsr;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.adobe.gl.runtime6.jdbc.GLDataSourceFactory;
import com.adobe.gl.runtime6.jdbc.GLDataSource;

/**
 * The destroy method of this servlet shuts down all of the application's
 * active data sources, giving them a chance to release pooled database
 * connections when the webapp is unloaded.
 */
public class DataSourceRegister extends HttpServlet {
	public void
	destroy() {
		ServletContext appl = getServletContext();
		GLDataSourceFactory gx = null;

		log(10, "DataSourceRegister destroy {"/*}*/);
		synchronized (appl) {
			gx = (GLDataSourceFactory)
				appl.getAttribute(GLDataSourceFactory.FACTNAME);
			appl.removeAttribute(GLDataSourceFactory.FACTNAME);
		}
		if (gx != null)
			for (Enumeration e = gx.keys(); e.hasMoreElements();) {
				String name = (String) e.nextElement();
				log(10, "Shutting down data source "+name);
				javax.sql.DataSource ds =
					gx.getDataSource(name);
				if (ds==null)
					log(1, "data source "+name+" null!");
				else if (ds instanceof GLDataSource)
					((GLDataSource) ds).shutdown();
				else
					log(1, "What kind of thing is "
						+ name);
			}
		log(10, /*{*/"DataSourceRegister destroy }");
	}

	private void
	log(int thresh, String msg) {
		if (logLevel >= thresh)
			System.out.println(msg);
	}

	private static final int logLevel = 10;
}
