/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.taglib6;
import java.io.*;
import java.util.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import com.adobe.gl.runtime6.utils.*;

public class RedirectTag extends TagSupport {
	private String page;
	private Hashtable args;
	public String getTargetPage() {
		return page;
	}
	public void setTargetPage(String page) {
		if (page != null)
			this.page = page;
	}
	public int doEndTag()
	{
		GLContext gl = (GLContext)
			pageContext.findAttribute(GLContext.GL_NAME);
		try {
			gl.redirect(page, args);
		}
		catch (Exception e) {
			gl.runtimeDebugMessage(e.toString());
		}
		return SKIP_PAGE;
	}
};
