<%--
   - GoLive actions for CustomMerchant.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page session="true"
	import="java.io.*,java.net.*,java.sql.*,java.util.*"
	errorPage="/config/actions/error.jsp"
 %><%@page import="org.w3c.dom.*"
 %><%@page import="org.w3c.dom.traversal.*"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.xml.*"
 %><%@page import="com.adobe.gl.runtime6.custommerchant.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %><gl:page id='gl'>
<%--
  -- custommerchant.actions6.jsp
  --%>
<%
	String s = request.getParameter("$csg");
	String name = gl.getFormValue("$AddToCart")!=null ? "add-to-cart"
		: gl.getFormValue("$ClearCart")!=null ? "clear-cart"
		: gl.getFormValue("$PurchaseNow")!=null ? "purchase"
		: gl.getFormValue("$UpdateOrder")!=null ?
			"change-order-form-props"
		: gl.getFormValue("$UpdateTotals")!=null ? "change-cart-props"
		: null;
	if (s==null || name==null) {
		response.sendError(400 /* SC_BAD_REQUEST */,
			"Bad request format (missing argument block $csg"
				+ " or action name).");
		return;
	}

	CSWError cse = CSWError.newError(gl, "");
	GLAction jackson = (GLAction) gl.unintern(s);
	if (jackson==null) {
		cse.DollarData().put("$$ERROR", "Invalid form repost.");
		gl.storeError(cse);
		redirect(gl, "$error", name);
		return;
	}

	if ("add-to-cart".equals(name))
		addToCart(gl, (CMCartAction) jackson, name);
	else if ("clear-cart".equals(name))
		clearCart(gl, (CMCartAction) jackson, name);
	else if ("purchase".equals(name))
		purchaseNow(gl, (CMOrderAction) jackson, name);
	else if ("change-order-form-props".equals(name))
		updateOrder(gl, (CMOrderAction) jackson, name);
	else if ("change-cart-props".equals(name))
		updateCart(gl, (CMCartAction) jackson, name);
 %></gl:page>
<%!

	private static void
	addToCart(GLContext gl, CMCartAction act, String name)
		throws GLException, IOException
	{
		Hashtable a = getFormValues(gl);
		initAction(a, name, act.merchantID, act.shopperID);
		a.put("description", act.description);
		a.put("sku", act.sku);
		a.put("unit-price", act.unitPrice);

		String result = cmAction(gl, act.providerURL, a);
		redirect(gl, result, name);
	}

	private static void
	clearCart(GLContext gl, CMCartAction act, String name)
		throws GLException, IOException
	{
		Hashtable a = getFormValues(gl);
		initAction(a, name, act.merchantID, act.shopperID);

		String result = cmAction(gl, act.providerURL, a);
		redirect(gl, result, name);
	}

	private static Hashtable
	getFormValues(GLContext gl) {
		Hashtable a = (Hashtable) gl.getRequestParameters().clone();
		String[] keys = GLUtils.hkeys(a);
		for (int i = 0; i < keys.length; ++i) {
			if (keys[i].startsWith("$key[")) { /* ] */
				Object o = a.get(keys[i]);
				a.remove(keys[i]);
				a.put("sku["+keys[i].substring(5), o); //]
			}
			else if (keys[i].startsWith("$"))
				a.remove(keys[i]);
		}
		return a;
	}

	private static String
	cmAction(GLContext gl, String providerURL, Hashtable a)
		throws GLException, IOException
	{
		String query = new StringBuffer(providerURL).append("?")
			.append(dumbQueryArrayToString(a))
			.toString();
		try {
			Document doc = GLXML.asDom(gl, query);
			return GLXML.asText(doc.getDocumentElement(), "*");
		}
		catch (Exception e) {
			return "$error -- missing/malformed result for "
				+ query;
		}
	}

	private static void
	purchaseNow(GLContext gl, CMOrderAction act, String name)
		throws GLException, IOException
	{
		Hashtable a = getFormValues(gl);
		initAction(a, name, act.merchantID, act.shopperID);

		String result = cmAction(gl, act.providerURL, a);
		redirect(gl, result, name);
	}

	private static void
	updateCart(GLContext gl, CMCartAction act, String name)
		throws GLException, IOException
	{
		Hashtable a = getFormValues(gl);
		initAction(a, name, act.merchantID, act.shopperID);

		String result = cmAction(gl, act.providerURL, a);
		redirect(gl, result, name);
	}

	private static void
	updateOrder(GLContext gl, CMOrderAction act, String name)
		throws GLException, IOException
	{
		Hashtable a = getFormValues(gl);
		initAction(a, name, act.merchantID, act.shopperID);
		stripIndices(a);

		String result = cmAction(gl, act.providerURL, a);
		redirect(gl, result, name);
	}

 %>
<%!
	/*
	 * -- Subroutines.
	 */

	private static String
	dumbQueryArrayToString(Hashtable a) {
		Enumeration e = a.keys();
		StringBuffer t = new StringBuffer();
		String sep = "";
		while (e.hasMoreElements()) {
			String k = (String) e.nextElement();
			t.append(sep); sep = "&";
			t.append(k);
			t.append("=");
			t.append(URLEncoder.encode((String) a.get(k)));
		}
		return t.toString();
	}

	private static String
	getNamedURL(GLContext gl, String action, String flag) {
		return gl.getRequest().getParameter(
			GLUtils.actionParam(action, flag));
	}

	private static void
	initAction(Hashtable a, String name, String nathalie, String shopper) {
		a.put("action", name);
		a.put("merchant-id", nathalie);
		a.put("shopper-id", shopper);
	}

	private static boolean
	ok(String result) {
		return result.indexOf("$error") != 0
			&& result.indexOf("-error>") < 0;
	}

	private static void
	redirect(GLContext gl, String result, String name)
		throws GLException, IOException
	{
		String flag = "success";
		Hashtable query = null;
		boolean okp = ok(result);
		if (!okp) {
			query = new Hashtable();
			query.put("FORMERR", "");
			flag = "failure";
			gl.getRequest().setAttribute("$$cm-return",
				GLXOut.xmlEncode(result));
		}
		gl.redirect(getNamedURL(gl, name, flag), query, okp);
	}

	private static void
	stripIndices(Hashtable a) {
		Vector v = new Vector();
		for (Enumeration e = a.keys(); e.hasMoreElements();) {
			String name = (String) e.nextElement();
			if (name.startsWith("$") || name.indexOf('[') < 0) //]
				continue;
			v.add(name);
		}
		for (int i = 0; i < v.size(); ++i) {
			String name = (String) v.get(i);
			int lb = name.indexOf('[');	//]
			Object o = a.get(name);
			a.remove(name);
			a.put(name.substring(0, lb), o);
		}
	}

 %>
