<%--
   - GoLive
   - Design-time support for the Block Navigator view content source.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page import="java.util.*,java.io.*"
	errorPage="/config/actions/error.jsp"
	contentType="text/xml;charset=utf-8"
	buffer="16kb"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %><%--
  .. Requests served by this page:
  ..
  .. blockview.info6.jsp
  .. blockview.info6.jsp?datasources=<all|distinct>
  ..	<DATASOURCES>
  ..		<DATASOURCE>
  ..
  .. blockview.info6.jsp?test=<ignored>
  ..	<TESTRESULT>
  ..		<RECORD NUMBER='1'>
  ..			<FIELD COLUMN='...'>value
  ..		<MESSAGE>error text</MESSAGE>
  ..
  --%><gl:page id='gl'><%
	gl.rejectUnauthorizedCallers();
	GLXOut.headerComment(out, GLUtils.reqstr(request), 0);

	Hashtable a = gl.getRequestParameters();
	try {
		if (GLUtils.has(a, "test"))
			dumpTestResults(gl);
		else if (GLUtils.has(a, "csn"))
			dumpSchema(gl);
		else if (GLUtils.has(a, "demo"))
			dumpDemo(gl);
		else
			dumpDataSources(gl);
	}
	catch (Exception e) {
		out.clearBuffer();
		GLXOut.errorMessage(out, "1", e.toString());
	}
 %>
</gl:page>
<%!
	private static void
	dumpDataSources(GLContext gl)
		throws IOException
	{
		JspWriter out = gl.getOut();
		GLXOut.stag(out, "DATASOURCES", 0);
		GLXOut.etag(out, "DATASOURCES", 0);
	}

	private static void
	dumpDemo(GLContext gl)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		CSWError cse = CSWError.newError(gl, "");
		CSWBlockNavigatorView csn =
			CSWBlockNavigatorView.newView(gl, "block=1", cse,
				"field_displayer");
		dumpDemo0(gl, "cse.Value('Link_URL')", cse.Value("Link_URL"));
		dumpDemo0(gl, "null", null);
		dumpDemo0(gl, "cletus", "cletus");
		dumpDemo0(gl, "", "");
		dumpDemo0(gl, "Integer(0)", new Integer(0));
		dumpDemo0(gl, "Integer(1)", new Integer(1));
		dumpDemo0(gl, "Date()", new Date());
	}
	private static void
	dumpDemo0(GLContext gl, String name, Object value)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		GLXOut.headerComment(out,
			"IsEmpty[" + name + ":"
				+ value + "] "
				+ GLCondition.IsEmpty(gl, value),
			0);
	}

	private static void
	dumpSchema(GLContext gl)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		CSWError cse = CSWError.newError(gl, "");
		CSWBlockNavigatorView csn =
			CSWBlockNavigatorView.newView(gl, "block=1", cse,
				"field_displayer");
		GLXOut.stag(out, "STRUCTURE", 0);
		for (int j = 1; j <= csn.getColumnCount(); ++j) {
			GLXOut.stag(out, "FIELD", 1);
			GLXOut.oneElement(out, "NAME",
				csn.getColumnName(j), 2);
			GLXOut.etag(out, "FIELD", 1);
		}
		GLXOut.etag(out, "STRUCTURE", 0);
	}

	private static void
	dumpTestResults(GLContext gl)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		CSWError cse = CSWError.newError(gl, "");
		CSWBlockNavigatorView csn =
			CSWBlockNavigatorView.newView(gl, "", cse,
				"field_displayer");
		GLXOut.stag(out, "TESTRESULT", 0);
		GLXOut.stag(out, "RECORD NUMBER='1'", 1);
		for (int j = 1; j <= csn.getColumnCount(); ++j) {
			String fname = csn.getColumnName(j);
			String ftag = GLUtils.cat("FIELD COLUMN='",
				GLXOut.xmlEncode(fname), "'", "");
			GLXOut.oneElement(out, ftag,
				GLXOut.xmlEncode(csn.Value(j)), 2);
		}
		GLXOut.etag(out, "RECORD", 1);
		GLXOut.etag(out, "TESTRESULT", 0);
	}
 %>
