<%--
   - GoLive
   - Design-time support for CustomMerchant shopping cart ecommerce providers.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page import="java.util.*,java.io.*"
	errorPage="/config/actions/error.jsp"
	contentType="text/xml;charset=utf-8"
	buffer="16kb"
 %><%@page import="org.w3c.dom.*"
 %><%@page import="org.w3c.dom.traversal.*"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.xml.*"
 %><%@page import="com.adobe.gl.runtime6.custommerchant.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %><%--
  .. Requests served by this page:
  ..
  .. custommerchant.cart.info6.jsp
  .. custommerchant.cart.info6.jsp?datasources=<all|distinct>
  ..	<DATASOURCES>
  ..		<DATASOURCE>
  .. 
  .. custommerchant.cart.info6.jsp?provider=<name>
  ..	<STRUCTURE>
  ..		<FIELD>
  ..			<NAME>
  ..			<FRIENDLYNAME>
  ..
  .. custommerchant.cart.info6.jsp?getecp=<name>
  .. custommerchant.cart.info6.jsp?putecp=<name>&data=<xml>
  .. custommerchant.cart.info6.jsp?delete=<name>
  ..
  .. custommerchant.cart.info6.jsp?test=<ignored>&provider=<name>
  ..	<TESTRESULT>
  ..		<RECORD>
  ..			<FIELD COLUMN='name'>value</FIELD>
  ..
  --%><gl:page id='gl'><%
	gl.rejectUnauthorizedCallers();
	// GLXOut.headerComment(out, GLUtils.reqstr(request), 0);
	Hashtable a = gl.getRequestParameters();

	try {
		if (GLUtils.has(a, "delete"))
			delecp(gl, (String) a.get("delete"));
		else if (GLUtils.has(a, "getecp"))
			getecp(gl, (String) a.get("getecp"));
		/* "test" must precede "provider" */
		else if (GLUtils.has(a, "test"))
			testecp(gl, (String) a.get("provider"));
		else if (GLUtils.has(a, "putecp"))
			putecp(gl, (String) a.get("putecp"),
				(String) a.get("data"));
		else if (GLUtils.has(a, "provider"))
			dumpSchema(gl, (String) a.get("provider"));
		else
			dumpDataSources(gl,
				"all".equals((String) a.get("datasources")));
	}
	catch (Exception e) {
		out.clearBuffer();
		GLXOut.errorMessage(out, "1", e.toString());
	}
 %>
</gl:page>
<%!

	private void
	delecp(GLContext gl, String db)
		throws IOException, GLException
	{
		File f = CMUtils.getDataSourceFile(gl, db);
		if (f.exists())
			f.delete();
	}

	/**
	 * If DOC is a single ERROR element, returns it as a string; else null.
	 */
	private static String
	docError(Document doc)
		throws GLException
	{
		String err = GLXML.asText(doc.getDocumentElement(), "/ERROR");
		if (err != null && err.length() > 0)
			return err;
		return null;
	}

	private void
	dumpDataSources(GLContext gl, boolean all)
		throws GLException, IOException
	{
		GLXOut.dumpDataSources(gl.getOut(),
			CMUtils.getDataSources(gl, all));
	}

	private void
	dumpSchema(GLContext gl, String provider)
		throws GLException, IOException
	{
		Properties pinfo = CMUtils.getProviderInfo(gl, provider);
		String nathalie = pinfo.getProperty("merchant-id");
		String surl = pinfo.getProperty("url");
		String query = new StringBuffer(surl)
			.append("?action=get-cart-schema")
			.append("&merchant-id=").append(nathalie)
			.toString();
		Document doc = GLXML.asDom(gl, query);
		JspWriter out = gl.getOut();
		String x = GLXML.asText(doc.getDocumentElement(), "*");
		out.print(x);
		GLXOut.crlf(out);
	}

	/**
	 * Returns true iff DOC is an error return
	 * (and prints its contents to the client via OUT).
	 */
	private static boolean
	errorMessage(Document doc, JspWriter out)
		throws GLException, IOException
	{
		String err = docError(doc);
		if (err != null) {
			out.print(err);
			GLXOut.crlf(out);
			return true;
		}
		return false;
	}

	private void
	getecp(GLContext gl, String db)
		throws IOException, GLException
	{
		HttpServletResponse resp = gl.getResponse();
		resp.setContentType("text/plain; charset="
			+ resp.getCharacterEncoding());
		File f = CMUtils.getDataSourceFile(gl, db);
		Reader rr = null;
		try {
			rr = new BufferedReader(new FileReader(f));
			GLUtils.dumpTextFile(rr, gl.getOut());
		}
		finally {
			try { if (rr!=null) rr.close(); }
			catch (IOException e) {}
		}
	}

	private void
	putecp(GLContext gl, String db, String data)
		throws GLException
	{
		File f = CMUtils.getDataSourceFile(gl, db);
		int rc = GLUtils.putFile(f, data);
		if (rc != 0)
			throw new GLException("Save "+db+": error "+rc);
	}

	private void
	testecp(GLContext gl, String provider)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		java.util.Properties pinfo =
			CMUtils.getProviderInfo(gl, provider);
		String nathalie = pinfo.getProperty("merchant-id");
		String surl = pinfo.getProperty("url");
		String query = new StringBuffer(surl)
			.append("?action=get-cart")
			.append("&merchant-id=").append(nathalie)
			.append("&shopper-id=test")
			.toString();
		Document doc = GLXML.asDom(gl, query);
		if (errorMessage(doc, out))
			return;

		Document sdoc =
			GLXML.asDom(gl, "custommerchant.jxform.info6.xsl");
		String myname = gl.getRequest().getContextPath()
			+ "/config/info/custommerchant.cart.info6.jsp";
		Document ndoc = GLXML.transform(myname, doc, sdoc);

		String x = GLXML.asText(ndoc.getDocumentElement(), "/");
		out.print(x);
		GLXOut.crlf(out);
	}
 %>
