<%--
   - GoLive
   - Design-time support for JDBC data sources.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page import="java.sql.*,java.util.*,java.io.*"
	session="false"
	errorPage="/config/actions/error.jsp"
	contentType="text/xml;charset=utf-8"
	buffer="16kb"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.jdbc.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %><gl:page id="gl">
<%--
  .. Requests served by this page:
  ..
  .. jdbc.info6.jsp
  .. jdbc.info6.jsp?datasources=<all|distinct>
  ..	<DATASOURCES>
  ..		<DATASOURCE>
  .. 
  .. jdbc.info6.jsp?db=Magazine
  ..	<DATATYPES>
  ..		<DATATYPE>
  ..			<TYPE_NAME>
  ..			<WHEREABLE>
  ..			<LITERAL_PREFIX>
  ..			<LITERAL_SUFFIX>
  .. 
  .. jdbc.info6.jsp?db=Magazine&types=*
  ..	<TABLES>
  ..		<TABLE>...
  .. 
  .. jdbc.info6.jsp?db=Magazine&sql=select+*+from+Projects
  ..	<COLUMNS>
  ..		<COLUMN>
  ..			<COLUMN_NAME>
  ..			<TYPE_NAME>
  .. 
  .. jdbc.info6.jsp?db=Magazine&sql=select+*+from+Projects&records=N
  .. jdbc.info6.jsp?db=Magazine&sql=select+*+from+Projects&records=N,K
  ..	<RECORDSET>
  ..		<RECORD NUMBER='1'>	// then '2', '3', ...
  ..			<FIELD COLUMN="fieldname">value</FIELD>
  .. records=N is a shorthand for records=N,N.  If K<1, no records are
  .. returned.  To request all records, use 1 for N and an absurdly large
  .. value for K.
  .. 
  .. jdbc.info6.jsp?getsbs=Magazine
  .. jdbc.info6.jsp?putsbs=Magazine&data=...
  .. jdbc.info6.jsp?delete=Magazine.jdbc.sbs
  ..
  .. jdbc.info6.jsp?test=ignored&db=Magazine&sql=select+*+from+Projects
  ..	<TESTRESULT>
  ..		... otherwise like db=...&sql=...&records=1,1 ...
  .. 
  .. jdbc.info6.jsp?db=Magazine&keys=Projects
  ..	<KEYS>
  ..		<PRIMARY_KEY>...
  --%><%
	Hashtable a = gl.getRequestParameters();
	// GLXOut.headerComment(out, GLUtils.reqstr(request), 0);

	try {
		if (GLUtils.has(a, "db&sql&test"))
			dumpTableContents(gl, (String) a.get("db"),
				(String) a.get("sql"), "1,1", "TESTRESULT");
		else if (GLUtils.has(a, "db&sql&records"))
			dumpTableContents(gl, (String) a.get("db"),
				(String) a.get("sql"),
				(String) a.get("records"), "RECORDSET");
		else if (GLUtils.has(a, "db&sql"))
			dumpTableSchema(gl, (String) a.get("db"),
				(String) a.get("sql"));
		else if (GLUtils.has(a, "db&keys"))
			dumpPrimaryKeys(gl, (String) a.get("db"),
				(String) a.get("keys"));
		else if (GLUtils.has(a, "db&types"))
			dumpTableNames(gl, (String) a.get("db"),
				(String) a.get("types"));
		else if (GLUtils.has(a, "db"))
			dumpDataTypes(gl, (String) a.get("db"));
		else if (GLUtils.has(a, "getsbs"))
			getsbs(gl, (String) a.get("getsbs"));
		else if (GLUtils.has(a, "putsbs"))
			putsbs(gl, (String) a.get("putsbs"),
			(String) a.get("data"));
		else if (GLUtils.has(a, "delete"))
			delsbs(gl, (String) a.get("delete"));
		else
			dumpDataSources(gl,
				"all".equals((String) a.get("datasources")));
	}
	catch (SQLException sqe) {
		out.clearBuffer();
		GLXOut.errorMessage(out, "1", sqe.toString());
	}
	catch (Throwable e) {
		out.clearBuffer();
		String s = e.toString();
		int ix = s.indexOf("java.lang.ClassNotFoundException");
		if (ix >= 0) {
			s = new StringBuffer(s)
				.append("\r\n\r\n")
				.append("Cannot find the database driver ")
				.append("class.\r\n")
				.append("Perhaps it is not installed ")
				.append("in the web application, or is ")
				.append("simply misspelled in the datasource ")
				.append("description file.\r\n")
				.toString();
		}
		else if ((ix = s.indexOf(": No suitable driver")) >= 0) {
			s = new StringBuffer(s)
				.append("\r\n\r\n")
				.append("Perhaps there is a typographical ")
				.append("error in the dburl field of the ")
				.append("datasource description file.\r\n")
				.toString();
		}
		GLXOut.errorMessage(out, "0", s);
	}
 %></gl:page><%!

	private void
	delsbs(GLContext gl, String db)
		throws IOException, GLException
	{
		File f = GLJdbc.getDataSourceFile(gl, db);
		if (f.exists())
			f.delete();
	}

	private void
	dumpDataSources(GLContext gl, boolean all)
		throws IOException, SQLException, GLException
	{
		GLXOut.dumpDataSources(gl.getOut(),
			GLJdbc.getDataSources(gl, all));
	}

	private void
	dumpDataTypes(GLContext gl, String db)
		throws IOException, SQLException, GLException
	{
		Connection con = GLJdbc.getConnection(gl, db);
		DatabaseMetaData dbmd = con.getMetaData();
		ResultSet rs = dbmd.getTypeInfo();
		JspWriter out = gl.getOut();

		GLXOut.stag(out, "DATATYPES", 0);
		while (rs.next()) {
			GLXOut.stag(out, "DATATYPE", 1);
			GLXOut.oneElement(out, "TYPE_NAME",
				GLUtils.cat(
					GLXOut.dummy(rs.getObject(2)),
					"<!--",
					GLXOut.dummy(rs.getObject(1)),
					"-->"),
				2);
			GLXOut.oneElement(out, "WHEREABLE",
				(rs.getInt(9) != DatabaseMetaData.typePredNone
					? "True" : "False"),
				2);
			GLXOut.oneElement(out, "LITERAL_PREFIX",
				GLXOut.dummy(rs.getObject(4)), 2);
			GLXOut.oneElement(out, "LITERAL_SUFFIX",
				GLXOut.dummy(rs.getObject(5)), 2);
			GLXOut.etag(out, "DATATYPE", 1);
		}
		GLXOut.etag(out, "DATATYPES", 0);
	}

	/*
	 * XXX with postgresql this seems to return the wrong table!
	 * We get something that looks like DATATYPES instead.
	 */
	private void
	dumpPrimaryKeys(GLContext gl, String db, String tablename)
		throws IOException, SQLException, GLException
	{
		Connection con = GLJdbc.getConnection(gl, db);
		DatabaseMetaData dbmd = con.getMetaData();
		/*
		 * bug: Oracle insists, and Postgres doesn't mind, that
		 * we coerce the table name to uppercase.
		 * But MySQL objects strenuously.
		 */
		ResultSet rs = dbmd.getPrimaryKeys(null, null,
				tablename/*.toUpperCase()*/);
		JspWriter out = gl.getOut();
		GLXOut.stag(out, "KEYS", 0);
		while (rs.next()) {
			/*
			 * bug: Oracle returns keys from other schemas
			 * e.g., you ask for MAGAZINE, it returns items
			 * for both MAGAZINE and MAGAZINE_J1.
			 */
			final String schema = (String) rs.getObject(2);
			if (schema != null && !"".equals(schema)
			 && !db.equalsIgnoreCase(schema))
				continue;
			GLXOut.oneElement(out, "PRIMARY_KEY",
				rs.getObject(4), 2);
			out.println("<!--");
			try {
				GLXOut.oneElement(out, "TABLE_CAT",
					rs.getObject(1), 2);
				GLXOut.oneElement(out, "TABLE_SCHEM",
					schema, 2);
			}
			catch (SQLException e) {
			}
			GLXOut.oneElement(out, "TABLE_NAME",
				rs.getObject(3), 2);
			GLXOut.oneElement(out, "COLUMN_NAME",
				rs.getObject(4), 2);
			GLXOut.oneElement(out, "KEY_SEQ", rs.getObject(5), 2);
			GLXOut.oneElement(out, "PK_NAME", rs.getObject(6), 2);
			out.println("  -->");
		}
		GLXOut.etag(out, "KEYS", 0);
	}

	private void
	dumpTableNames(GLContext gl, String db, String tableTypes)
		throws IOException, SQLException, GLException
	{
		Connection con = null;
		DatabaseMetaData dbmd = null;
		ResultSet rs = null;
	    try {
		con = GLJdbc.getConnection(gl, db);
		dbmd = con.getMetaData();
		JspWriter out = gl.getOut();
		GLXOut.stag(out, "TABLES", 0);
		String[] typematch = tableTypes.equals("*") ? null
			: GLUtils.split(",", tableTypes);
		String[] badSchemas = new String[] {
			"SYS", "SYSTEM"
		};
		rs = dbmd.getTables(null, null, "%", null);
		while (rs.next()) {
			String ttype = rs.getString(4),
				tschema = rs.getString(2);
			if (!empty(ttype) && typematch != null
				 && !GLUtils.any(typematch, ttype)
			 || !empty(tschema) && GLUtils.any(badSchemas, tschema))
				continue;
			if (!empty(tschema)
			 && !tschema.equalsIgnoreCase(db))
				continue;
			GLXOut.oneElement(out, "TABLE",
				GLXOut.dummy(rs.getString(3)), 1);
			out.println("<!--");
			GLXOut.oneElement(out, "TABLE_CAT",
				GLXOut.dummy(rs.getString(1)), 1);
			GLXOut.oneElement(out, "TABLE_SCHEM",
				GLXOut.dummy(tschema), 1);
			GLXOut.oneElement(out, "TABLE_TYPE",
				GLXOut.dummy(ttype), 1);
			GLXOut.oneElement(out, "REMARKS",
				GLXOut.dummy(rs.getString(5)), 1);
			out.println("  -->");
		}
		GLXOut.etag(out, "TABLES", 0);
	    }
	    finally {
		if (rs != null) try {
			rs.close();
		} catch (Throwable e) {}
		if (con != null) try {
			con.close();
		} catch (Throwable e) {}
	    }
	}

	private void
	dumpTableContents(GLContext gl, String db, String sql, String records,
		String tag)
		throws IOException, SQLException, GLException
	{
		String[] rex = GLUtils.split(",", records);
		int nr0 = 0, nr1 = 0;
		try {
			nr0 = rex.length < 1 ? 0
				: Integer.parseInt(rex[0]);
			nr1 = rex.length < 2 ? nr0
				: Integer.parseInt(rex[1]);
		} catch (Exception e) {}

		if (nr0 < 1)
			nr0 = 1;
		Connection con = GLJdbc.getConnection(gl, db);
		Statement st = con.createStatement();
		gl.runtimeDebugMessage("SQL: "+sql);
		ResultSet rs = st.executeQuery(sql);
		ResultSetMetaData mdata = rs.getMetaData();
		int ncol = mdata.getColumnCount();
		JspWriter out = gl.getOut();

		GLXOut.stag(out, tag, 0);
		for (int i = 0; ++i <= nr1 && rs.next();) {
			if (i < nr0)
				continue;
			GLXOut.indent(out, 1);
			out.print("<RECORD NUMBER='");
			out.print(i);
			out.print("'>\r\n");
			for (int j = 1; j <= ncol; ++j) {
				GLXOut.indent(out, 2);
				out.print("<FIELD COLUMN='");
				out.print(GLXOut.xmlEncode(
					mdata.getColumnName(j)));
				out.print("'>");
				out.print(
					GLXOut.xmlEncode(rs.getObject(j)));
				GLXOut.etag(out, "FIELD", 0);
			}
			GLXOut.etag(out, "RECORD", 1);
		}
		GLXOut.etag(out, tag, 0);

		rs.close();
		st.close();
	}

	private void
	dumpTableSchema(GLContext gl, String db, String sql)
		throws IOException, SQLException, GLException
	{
		Connection con = GLJdbc.getConnection(gl, db);
		Statement st = con.createStatement();
		ResultSet rs = st.executeQuery(sql);
		ResultSetMetaData mdata = rs.getMetaData();
		int ncol = mdata.getColumnCount();
		JspWriter out = gl.getOut();

		GLXOut.stag(out, "COLUMNS", 0);
		for (int j = 1; j <= ncol; ++j) {
			GLXOut.stag(out, "COLUMN", 1);
			GLXOut.oneElement(out, "COLUMN_NAME",
				mdata.getColumnName(j), 2);
			GLXOut.oneElement(out, "TYPE_NAME",
				""+mdata.getColumnType(j), 2);
			GLXOut.indent(out, 2);
			out.print("<!-- " + mdata.getColumnTypeName(j)
				+ " -->\r\n");
			GLXOut.etag(out, "COLUMN", 1);
		}
		GLXOut.etag(out, "COLUMNS", 0);
	}

	private static boolean
	empty(String s) {
		return s==null || GLNull.val.equals(s) || "".equals(s);
	}

	private void
	getsbs(GLContext gl, String db)
		throws IOException, GLException
	{
		HttpServletResponse resp = gl.getResponse();
		resp.setContentType("text/plain; charset="
			+ resp.getCharacterEncoding());

		File f = GLJdbc.getDataSourceFile(gl, db);
		if (!f.exists()) {
			resp.setStatus(404);
			return;
		}
		Reader rr = null;
		try {
			rr = new BufferedReader(new FileReader(f));
			GLUtils.dumpTextFile(rr, gl.getOut());
		}
		catch (IOException e) {
			resp.setStatus(403);
		}
		finally {
			try { if (rr!=null) rr.close(); }
			catch (IOException e) {}
		}
	}

	private void
	putsbs(GLContext gl, String db, String data)
		throws GLException
	{
		File f = GLJdbc.getDataSourceFile(gl, db);
		int rc = GLUtils.putFile(f, data);
		if (rc != 0)
			throw new GLException("Save "+db+": error "+rc);
	}
 %>
