<%--
   - GoLive
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page session="false"
	contentType="text/html;charset=utf-8"
	errorPage="/config/actions/error.jsp"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%
	GLContext gl = new GLContext(pageContext);
	Double[] d = new Double[] {
		new Double(8.33),
		new Double(16384.0),
		new Double(-1256.0),
		new Double(0.142857)
	};
	String[] e = new String[] {
		"$42",
		"$0.42",
		"($.42)",
		"-.42"
	};
	final java.util.Date now = new java.util.Date();
	final int yes = GLNumberFormat.useTrue,
		no = GLNumberFormat.useFalse,
		maybe = GLNumberFormat.useDefault;
 %>
<html>
<head>
<title>Numbers and dates</title>
<style><!--
	body {
		background-color: #f0fff0;
		color: #003300;
		margin: 4%;
	}
	th {
		background-color: #003300;
		color: #ccffcc;
	}
	td {
		background-color: #ccffcc;
		color: #003300;
	}
	.h3 {
		background-color: #ccffcc;
	}
	h2 {
		align: center;
	}
--></style>
</head><body>
<h2>Number and date formatting functions</h2>
<p>
The underlying implementation for number formatting,
<em>java.text.NumberFormat</em>,
is not well-matched to GL's model of "call a function with a bunch
of parameters."
So we provide these (hopefully simple) wrappers.
<p>
The underlying implementation for date formatting,
<em>java.text.DateFormat</em>,
has a better match to the style, but still requires a wrapper because
GL assumes that all parameters are in the specified order in a single
list: it can't do things like<br>
<code>&nbsp;&nbsp;&nbsp;&nbsp;
DateFormat.getDateInstance($3, $1.getUserLocale()).format((java.util.Date)$2);
</code>
<p>
These functions honour your <code>"Accept-Language:"</code>
HTTP headers.
For debugging purposes, you can override the locale with the $LC
query parameter, e.g., <code>
<%=request.getRequestURI()%>?%24LC=ja_JP<br>
</code>
Note:
if the browser sends <code>en</code>, we default <code>en_US</code>.
<div class="h3">
<h3>Currency</h3>
</div>
<p>
The row legends can be decoded as<br>
<code><strong>0</strong></code> required digit<br>
<code><strong>#</strong></code> optional digit<br>
<strong><code>. </code>(period)</strong> decimal separator<br>
<strong><code>, </code>(comma)</strong> group separator<br>
<code><strong>Locale</strong></code> locale defaults
<p>
<table>
<tr>
<th>#.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 2, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>Locale
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						-1, -1, maybe, maybe);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.000000
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						6, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.00####
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>0.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 2, 1, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>00.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 2, 2, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>#,###
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 2, 0, yes);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>#?###</th>
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, d[j],
						2, 2, 0, maybe);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>#?### Strings</th>
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Currency(gl, e[j],
						2, 2, 0, maybe);
 %><td><%=s%><%
			}
 %>
</tr>
</table>
<div class="h3">
<h3>Number</h3>
</div>
<p>
<table>
<tr>
<th>#.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 2, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>Locale
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 2, maybe, maybe);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.000000
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						6, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.00####
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>0.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 2, 1, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>00.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 2, 2, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>#,###
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Number(gl, d[j],
						2, 2, 0, yes);
 %><td><%=s%><%
			}
 %>
</tr>
</table>
<div class="h3">
<h3>Percent</h3>
</div>
<p>
<table>
<tr>
<th>#.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 2, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>Locale
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 2, maybe, maybe);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.000000
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						6, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>.00####
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 6, 0, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>0.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 2, 1, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>00.00
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 2, 2, no);
 %><td><%=s%><%
			}
 %>
</tr>
<tr>
<th>#,###
<%
			for (int j = 0; j < d.length; ++j) {
				String s =
					GLNumberFormat.Percent(gl, d[j],
						2, 2, 0, yes);
 %><td><%=s%><%
			}
 %>
</tr>
</table>
<div class="h3">
<h3>DateTime</h3>
</div>
<p>
<table>
<tr>
<th>FULL Date, FULL Time
<td><%=GLDateFormat.DateTime(gl, now, GLDateFormat.FULL, GLDateFormat.FULL)%>
</tr><tr>
<th>LONG Date
<td><%=GLDateFormat.Date(gl, now, GLDateFormat.LONG)%>
</tr><tr>
<th>MEDIUM Date
<td><%=GLDateFormat.Date(gl, now, GLDateFormat.MEDIUM)%>
</tr><tr>
<th>SHORT Date
<td><%=GLDateFormat.Date(gl, now, GLDateFormat.SHORT)%>
</tr><tr>
<th>LONG Time
<td><%=GLDateFormat.Time(gl, now, GLDateFormat.LONG)%>
</tr><tr>
<th>MEDIUM Time
<td><%=GLDateFormat.Time(gl, now, GLDateFormat.MEDIUM)%>
</tr><tr>
<th>SHORT Time
<td><%=GLDateFormat.Time(gl, now, GLDateFormat.SHORT)%>
</table>
<div class="h3">
<h3>Bogus</h3>
<table>
<tr>
<th>null</th><td>
<%=GLDateFormat.DateTime(gl, null, GLDateFormat.FULL, GLDateFormat.FULL)%>
</td></tr><tr>
<th>GLNull</th><td>
<%=GLDateFormat.DateTime(gl, GLNull.val, GLDateFormat.FULL, GLDateFormat.FULL)%>
</td></tr><tr>
<th>"bob"</th><td>
<%=GLDateFormat.DateTime(gl, "bob", GLDateFormat.FULL, GLDateFormat.FULL)%>
</tr></table>
<%@include file="/WEB-INF/jspi/footer.jspi"%>
</body></html>
