<%--
   - GoLive
   - Diagnostics for the server-side authoring environment.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page
	import="java.io.*,java.lang.*,java.net.*,java.util.*,java.sql.*"
	errorPage="/config/actions/error.jsp"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.jdbc.*"
 %><%@page import="com.adobe.gl.runtime6.xml.*"
 %><%@page import="com.adobe.gl.runtime6.custommerchant.*"
 %><%@page import="org.apache.regexp.*"
 %><%@page import="org.w3c.dom.*"
 %><%@page contentType="text/html;charset=utf-8"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %>
<%@include file="troubleshootinginclude.jsp"%>
<%!
	private Test[]
	runTests(GLContext gl) {
		Vector v = new Vector();
		v.add(checkOutputFiles(gl));
		Test[] t = new Test[v.size()];
		v.copyInto(t);
		return t;
	}
	/*
	 * -- Tests
	 */

	static int errorCounter = 0;

	private Test
	checkOutputFiles(GLContext gl) {
		errorCounter = 0;	// reset
		Test test = new Test("Check dynamic (JSP) files");
		test.description =
			"This test detects commonly encountered authoring"
			+ " errors in dynamic (JSP) files.";
		String root = gl.getApplication().getRealPath("/");
		test.details.append("<p>Files are rooted in the")
			.append(" server directory: <br>")
			.append(root).append("<p>");

		test.details.append("<h4>")
			.append("Directory scan for output files.")
			.append("</h4>\r\n<p>\r\n");
		directoryScan(gl, test.details, new File(root), 1);
		if (errorCounter == 0) {
			test.pass("Dynamic files seem to be fine.");
		} else {
			test.fail("Problem(s) found in " + errorCounter + " file(s).");
		}
		return test;
	}

	/*
	 * -- Subroutines.
	 */

	/**
	 * Recursively traverse the directory tree below ROOTD, appending
	 * scan result of error string.
	 */
	private static void
	directoryScan(GLContext gl, StringBuffer ts, File rootd, int depth) {
		ts.append("<p>").append(rootd.toString()).append("<br>\r\n")
			.append("<table border=\"1\">\r\n")
			.append("<tr><th>Filename</th><th>Scan Result</th>")
			.append("<th>Lines</th></tr>\r\n");
		String[] files = rootd.list();
		Arrays.sort(files);
		for (int i = 0; i < files.length; ++i) {
			File f = new File(rootd, files[i]);
			if (files[i].endsWith(".jsp") && !f.isDirectory()) {
				ts.append("<tr><td>").append(files[i]).append("</td><td>");
				int line = fileScan(gl, ts, f);
				ts.append("</td><td align=\"right\">").append(line)
				.append(" line(s)</td></tr>\r\n");
			}
		}
		ts.append("</table>\r\n");
		for (int i = 0; i < files.length; ++i) {
			File f = new File(rootd, files[i]);
			if (f.isDirectory()) {
				if ((files[i].indexOf("config")  == -1) && 
					(files[i].indexOf("WEB-INF") == -1)) {
					directoryScan(gl, ts, f, 1+depth);
				}
			}
		}
	}

	private static int
	fileScan(GLContext gl, StringBuffer ts, File file) {
		LineNumberReader	lnr = null;
		int lineNumber = 0;
		int errorOnFile = 0;
		try {
			lnr = new LineNumberReader(new FileReader(file));
			String line = null;
			while ((line = lnr.readLine()) != null) {
				lineNumber = lnr.getLineNumber();
				if (line.indexOf("<%-- Mock Content") != -1) {
					break;	// do not check mock content
				}
				for (int i = 0; i < checkStrings.length; ++i) {
					String errStr = checkStrings[i][0];
					String errMsg = checkStrings[i][1];

					if (line.indexOf(errStr) != -1) {
						ts.append("<span class=\"failed\">")
						.append(errStr).append(" found at line #")
						.append(lineNumber)
						.append("</span><br>\r\n")
						.append(errMsg).append("<br>\r\n");
						errorOnFile++;
					}
				}
			}
		} catch (IOException e) {
			ts.append(e.toString());
		}
		finally {
			try { lnr.close(); }
			catch (Exception e) {}
			lnr = null;
		}

		if (errorOnFile == 0) {
			ts.append("<span class=\"passed\">OK</span><br>\r\n");
		} else {
			errorCounter++;
		}
		return lineNumber;
	}

	/**
	 * List of strings that we "know" it is error.
	 */
	private static final String[][] checkStrings = {
		new String[] { "Empty_Content_Source",
			"Content source is not set properly.",
		},
		new String[] { "Empty_Field",
			"Field is not set properly.",
		},
		new String[] { "EMPTY_VALUE",
			"Empty value.",
		},
	};
	private static final int WHICHPAGE = TSHOOT2;
	private static final String TITLE =
		"Adobe GoLive (JSP) Troubleshooting Report #2";
 %>
