<%--
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<gl:page id='gl'>
<html><head>
<title><%=TITLE%></title>
<link rel="stylesheet" href="gl.css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body>
<a name="top"></a>
<h1><%=TITLE%></h1>
<%	if (WHICHPAGE==TSHOOT) { %>
<p>
This report contains information about the status of your JSP
server software and the Adobe GoLive files installed on the server.
Below you will find the results of various tests performed by this
troubleshooting script.</p>
<p>
Please refer to the GoLive User Guide and "readme" file for more information
about installing and configuring your JSP server to work with Adobe GoLive.</p>
<%	} %>
<%	if (WHICHPAGE==TSHOOT2) { %>
<p>
This report contains the results of tests run on the dynamic (JSP)
files in your site.
The tests detect a number of simple,
commonly-encountered errors in the files.
</p>
<%	} %>
<%	if (WHICHPAGE!=TSHOOT2) { %>
<p>Click here for some
<a href="troubleshooting2.jsp">additional troubleshooting tools</a>.
These tools scan your entire site looking for dynamic content-specific
errors in pages.</p>
<%	} %>
<p>You can run test queries in SQL directly using this tool: 
<a href="testsql.jsp">testsql.jsp</a>.</p>
<%	if (WHICHPAGE!=TSHOOT) { %>
<p><a href="troubleshooting.jsp">Main troubleshooting page.</a></p>
<%	} %>

<h2>Test summary</h2>
<p>
<%
			gl.rejectUnauthorizedCallers();
			Test[] TestResults = runTests(gl);
 %>
<b><%=TestResults.length%> tests performed.</b></p>
<p>
<table border="1" cellpadding="4">
<tr>
<th>Test</th>
<th>Description</th>
<th>Results</th>
</tr>

<%
			for (int i = 0; i < TestResults.length; ++i) {
				Test test = TestResults[i];
 %>
<tr>
<td align="center"><a href="#<%=1+i%>"><%=1+i%></a></td>
<td><a href="#<%=1+i%>"><%=test.title%></a></td>
<td><%=test.resultStr()%></td>
</tr>
<%
			}
 %>
</table></p>
<h3>How to read the test results</h3>
<p>
<%=ResultName[0]%>: The test was successful.
No further action is required.
<p>
<%=ResultName[1]%>: Problem(s) were found.
Refer to the test report details for more information.
<p>
<%=ResultName[2]%>: This may or may not be a problem in your environment.
You should manually verify this operation.
Refer to the test report details for more information.

<%
			for (int i = 0; i < TestResults.length; ++i) {
				Test test = TestResults[i];
 %>
<hr width="75%" align="center">
<a name='<%=(1+i)%>'></a>
<h2>Test <%=(1+i)%>: <%=test.title%></h2>
<p><%=test.resultStr()%>: <%=test.summary%></p>
<p><b>Description: </b><%=test.description%></p>
<%=test.details%>
<p><a href='#top'>Back to Top</a></p>
<%
			}
 %>
<%@include file="/WEB-INF/jspi/footer.jspi"%>
</body></html>
</gl:page>
<%!
	class Test {
		public final int kPass = 0, kFail = 1, kVerify = 2;
		public Test(String title) {
			this.title = title;
			this.description = "";
			this.details = new StringBuffer();
			this.result = kPass;
			this.summary = "";
		}
		public void pass(String summary) {
			this.result = kPass;
			this.summary = summary;
		}
		public void fail(String summary) {
			this.result = kFail;
			this.summary = summary;
		}
		public void verify(String summary) {
			this.result = kVerify;
			this.summary = summary;
		}
		public String resultStr() {
			return ResultName[this.result];
		}
		public String title, description, summary;
		public StringBuffer details;
		private int result;
	};
	private static final String[] ResultName = new String[] {
		"<span class=\"passed\">Passed</span>",
		"<span class=\"failed\">Failed</span>",
		"<span class=\"verify\">Verify</span>"
	};


	/*
	 * -- Subroutines.
	 */

	/**
	 * Some of the parameter values we're printing get to be very
	 * long.  Here try to do something sensible about breaking them
	 * up into readable values.  The idea is that the longest strings
	 * are ':'-separated path values, so we break the lines on them.
	 */
	private static void
	checkOtherSubAddToTestDetails(Test test, String title,
		String syn, String Rx)
	{
		test.details
			.append("<div class='manual'>\r\n")
			.append("<span class='manualTitle'>")
			.append("<b>Symptom: </b>")
			.append(syn)
			.append("</span><p>\r\n")
			.append("<span class='manualPrescription'>")
			.append("<b>Prescription: </b>")
			.append(Rx)
			.append("</span></div>\r\n");
	}
	private static boolean
	empty(String s) {
		return s==null || GLNull.val.equals(s) || "".equals(s);
	}
	private static final int TSHOOT = 1, TSHOOT2 = 2;

 %>
