<%--
   - GoLive
   - Design-time support for XML data sources.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page import="java.util.*,java.io.*"
	errorPage="/config/actions/error.jsp"
	contentType="text/xml;charset=utf-8"
	buffer="16kb"
 %><%@page import="org.w3c.dom.*"
 %><%@page import="org.w3c.dom.traversal.*"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.xml.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %><%--
  .. Requests served by this page:
  ..
  .. xml.info6.jsp
  .. xml.info6.jsp?datasources=<all|distinct>
  ..	<DATASOURCES>
  ..		<DATASOURCE>
  .. 
  .. xml.info6.jsp?dstype=<name>
  ..	<STRUCTURE>
  ..		<FIELD>
  ..			<NAME>x/y/z</NAME>
  ..			<FRIENDLYNAME>z</FRIENDLYNAME>
  ..
  .. xml.info6.jsp?get=<name>
  ..	Return the contents of the named xds file.
  ..
  .. xml.info6.jsp?put=<name>&data=<xml>
  ..	Write data into the named xds file.
  ..
  .. xml.info6.jsp?delete=<name>
  ..	Write data into the named xds file.
  ..
  .. Note the asymmetry: get and put want an xds short name, but delete
  .. wants a (datasources/-rooted) filename.
  ..
  .. xml.info6.jsp?xml=<url>
  .. xml.info6.jsp?xml=<url>&xsl=<url>
  ..	<GL6XMLSOURCE xslurl='...' xmlurl='...' single=''>
  ..		<NODE name='...' type='attribute'/> ...
  ..		<NODE name='...' type='element'>
  ..			<NODE ...>
  ..
  .. xml.info6.jsp?test=<ignored>&dstype=<name>&xml=<url>
  ..	<TESTRESULT>
  ..		<RECORD NUMBER='<num>'>
  ..			<FIELD COLUMN='.'>
  ..		<MESSAGE>error text</MESSAGE>
  ..
  --%><gl:page id='gl'><%
	gl.rejectUnauthorizedCallers();
	// GLXOut.headerComment(out, GLUtils.reqstr(request), 0);
	Hashtable a = gl.getRequestParameters();

	try {
		if (GLUtils.has(a, "test"))
			dumpCSW(gl, (String) a.get("dstype"),
				absolutePath((String) a.get("test"), (String) a.get("xml")));
		else if (GLUtils.has(a, "dstype"))
			dumpSchema(gl, (String) a.get("dstype"));
		else if (GLUtils.has(a, "get"))
			dumpDataSource(gl, (String) a.get("get"));
		else if (GLUtils.has(a, "put"))
			putDataSource(gl, (String) a.get("put"),
				(String) a.get("data"));
		else if (GLUtils.has(a, "xml")) {
			/*
			 * We're sending a schema here, so we want
			 * to prune out non-unique elements on a
			 * single level.
			 */
			gl.getRequest().setAttribute(UQNAME, UQNAME);
			dumpDoc(gl, (String) a.get("xml"),
				(String) a.get("xsl"),
				(String) a.get("single"));
		}
		else if ("all".equals((String) a.get("datasources")))
			dumpDataSources(gl, true);
		else if (!GLUtils.has(a, "delete")) // this makes this the default if we don't recognize anything
			dumpDataSources(gl, false);
			
		if (GLUtils.has(a, "delete"))
			delete(gl, (String) a.get("delete"));
	}
	catch (Exception e) {
		out.clearBuffer();
		GLXOut.errorMessage(out, "1", e.toString());
	}
 %>
</gl:page>
<%!

	private String
	absolutePath(String basePath, String relativePath)
	{
		if (relativePath == null) {
			return null;
		}
		
		if (relativePath.startsWith("/")
		 || relativePath.indexOf("://") >= 0)
		{
			return relativePath;
		}

		String[] origurl = GLUtils.split("?", basePath);
		String[] newurl = GLUtils.split("?", relativePath);

		String[] origparts = GLUtils.split("/", origurl[0]);
		String[] newparts = GLUtils.split("/", newurl[0]);

		String[] origargs, newargs;
		if (origurl.length > 1) {
			origargs = GLUtils.split("&", origurl[1]);
		} else {
			origargs = new String[0];
		}
		if (newurl.length > 1) {
			newargs = GLUtils.split("&", newurl[1]);
		} else {
			newargs = new String[0];
		}
		
		int i;
		String[] finalparts;
		String firstpart = newparts[0];
		if (firstpart.endsWith(":")) {				// absolute href
			finalparts = newparts;
		} else {
			int keeporig = origparts.length - 1;	// first we'll get rid of the last part
			int startnew = 0;
			while ("..".equals(newparts[startnew])) {
				keeporig--;							// get rid of the last part
				startnew++;							// get rid of the ".."
			}
			Vector v = new Vector();
			for (i = 0; i < keeporig; i++) {
				v.add(origparts[i]);
			}
			for (i = startnew; i < newparts.length; i++) {
				v.add(newparts[i]);
			}
			finalparts = new String[v.size()];
			v.copyInto(finalparts);
		}
		
		String abspath = GLUtils.join("/", finalparts);
		if ((origargs.length + newargs.length) > 0) {
			abspath += "?";
			if (origargs.length > 0) {
				abspath += GLUtils.join("&", origargs);
			}
			if ((origargs.length > 0) && (newargs.length > 0)) {
				abspath += "&";
			}
			if (newargs.length > 0) {
				abspath += GLUtils.join("&", newargs);
			}
		}
		
		return abspath;	 	
	}
	
	private void
	delete(GLContext gl, String dstype)
		throws IOException, GLException
	{
		File f = CSWXML.getDataSourceFile(gl, dstype);
		if (f.exists())
			f.delete();
	}

	/**
	 * Tests the content source formed from data source DSTYPE and
	 * input XML.
	 */
	private void
	dumpCSW(GLContext gl, String dstype, String xml)
		throws GLException, IOException
	{
		if (dstype==null) {
			throw new GLException(
				"Missing/null dstype or xml parameter");
		}
		
		Document a = GLXML.asDom(gl,
			CSWXML.getDataSourceFile(gl, dstype));
			
		if (xml==null) {
			Node[] xn = GLXML.getNodes(a, "/*/@xmlurl");
			Attr attr = (Attr) xn[0];
			xml = attr.getValue();
		}
		xml = gl.mapPath(xml);

		ContentSourceWrapper csw = CSWXML.GetXMLSource(gl,
			"block=1", dstype, xml,
			"Laissez les bon temps rouler.");
		JspWriter out = gl.getOut();

		GLXOut.stag(out, "TESTRESULT", 0);
		if (csw.RecordCount() > 0) {
			final String record =
				"RECORD NUMBER='"+csw.AbsolutePosition()+"'";
			GLXOut.stag(out, record, 1);
			dumpCSW(csw, a.getDocumentElement(), "", out);
			GLXOut.etag(out, record, 1);
		}
		GLXOut.etag(out, "TESTRESULT", 0);
	}
	
	private void
	dumpCSW(ContentSourceWrapper csw, Node n, String fullname, JspWriter out)
		throws GLException, IOException
	{
		Node[] en = GLXML.getNodes(n, "*");
		for (int i = 0; i < en.length; ++i) {
			Element e = (Element) en[i];
			String name = e.getAttribute("name");
			String type = e.getAttribute("type");
				
			if ("attribute".equals(type)) {
				GLXOut.oneElement(out,
					"FIELD COLUMN='"+GLXML.addPath(fullname, "@"+name)+"'",
					csw.Value("@"+name),
					2);
			}
			else if ("element".equals(type)) {
				if ("[body]".equals(name)) {
					GLXOut.oneElement(out,
						"FIELD COLUMN='"+("".equals(fullname) ? "[body]" : fullname)+"'",
						csw.Value("[body]".equals(name) ? "." : name),
						2);
				} else {
					GLXOut.oneElement(out,
						"FIELD COLUMN='"+GLXML.addPath(fullname, name)+"'",
						csw.Value(name),
						2);
				}
			}
			else if ("structure".equals(type)) {
				dumpCSW(csw.NestedCSW(name), e,
					GLXML.addPath(fullname, name), out);
			}
		}
	}

	private void
	dumpDataSource(GLContext gl, String dstype)
		throws GLException, IOException
	{
		File file = CSWXML.getDataSourceFile(gl, dstype);
		Reader br = null;

		try {
			br = new BufferedReader(new InputStreamReader(
				new FileInputStream(file), "utf-8"));
			GLUtils.dumpTextFile(br, gl.getOut());
		}
		finally {
			try { br.close(); } catch (IOException e) {}
		}
	}

	private void
	dumpDataSources(GLContext gl, boolean all)
		throws GLException, IOException
	{
		GLXOut.dumpDataSources(gl.getOut(),
			CSWXML.getDataSources(gl, all));
	}

	private void
	dumpDoc(GLContext gl, String xml, String xsl, String single)
		throws GLException, IOException
	{
		Document xmldoc = null, xsldoc = null;
		xml = gl.mapPath(xml);
		xmldoc = GLXML.asDom(gl, xml);
		if (xsl != null && !"".equals(xsl)) {
			xsl = gl.mapPath(xsl);
			xsldoc = GLXML.asDom(gl, xsl);
		}
		if (xsldoc != null)
			xmldoc = GLXML.transform(xml, xmldoc, xsldoc);
		dumpDoc(gl, xmldoc, xml, xsl, single);
	}

	private void
	dumpDoc(GLContext gl, Document doc, String xml, String xsl,
		String single)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();
		out.print("<GL6XMLSOURCE");
		out.print(" xslurl='");
		out.print(GLXOut.xmlEncode(GLXOut.dummy(xsl, "")));
		out.print("'");
		out.print(" xmlurl='");
		out.print(GLXOut.xmlEncode(GLXOut.dummy(xml, "")));
		out.print("'");
		out.print(" single='");
		out.print(GLXOut.xmlEncode(GLXOut.dummy(single, "")));
		out.print("'");
		out.print(">\r\n");

		dumpNode(gl, doc, "true".equals(single) ? "/*" : "/*/*", 1);

		out.print("</GL6XMLSOURCE>\r\n");
	}

	private void
	dumpNode(GLContext gl, Node top, String xpath, int depth)
		throws GLException, IOException
	{
		JspWriter out = gl.getOut();

		Node[] attributes =
			GLXML.getNodes(top, GLXML.addPath(xpath, "@*"));
		Node[] elements =
			GLXML.getNodes(top, GLXML.addPath(xpath, "*"));
			
		if ((attributes.length + elements.length) > 0) {
			dumpNodeHeader(out, "[body]", "hidden-element",
				GLXOut.SINGLETON, depth);
				
			boolean wantUnique =
				gl.getRequest().getAttribute(UQNAME) != null;
				
			Hashtable uhash = (wantUnique && (attributes.length > 0))
				? new Hashtable() : null;
			for (int i = 0; i < attributes.length; ++i) {
				Node n = attributes[i];
				String nname = n.getNodeName();
				if (uhash != null) {
					if (uhash.containsKey(nname))
						continue;
					uhash.put(nname, nname);
				}
				dumpNodeHeader(out, nname, "attribute",
					GLXOut.SINGLETON, depth);
			}
			attributes = null;
			
			uhash = (wantUnique && (elements.length > 0))
				? new Hashtable() : null;
			for (int i = 0; i < elements.length; ++i) {
				Node n = elements[i];
				String nname = n.getNodeName();
				if (uhash != null) {
					if (uhash.containsKey(nname))
						continue;
					uhash.put(nname, nname);
				}
				dumpNodeHeader(out, nname, "element",
					!GLXOut.SINGLETON, depth);
				dumpNode(gl, top, GLXML.addPath(xpath, nname), 1+depth);
				GLXOut.etag(out, "NODE", depth);
			}
		}
		else {
			dumpNodeHeader(out, "[body]", "element",
				GLXOut.SINGLETON, depth);
		}
	}

	/**
	 * Writes &lt;NODE name='NAME' type='TYPE'>\n to OUT.
	 * If SINGLETON, uses /> instead of > to close the tag.
	 */
	private static void
	dumpNodeHeader(JspWriter out, String name, String type,
		boolean singleton, int depth)
		throws IOException
	{
		GLXOut.indent(out, depth);
		out.print("<NODE name='");
		out.print(name);
		out.print("' type='");
		out.print(type);
		out.print(singleton ? "'/>" : "'>");
		GLXOut.crlf(out);
	}

	private void
	dumpSchema(GLContext gl, String dstype)
		throws GLException, IOException
	{
		Document doc = GLXML.asDom(gl,
			CSWXML.getDataSourceFile(gl, dstype));
		JspWriter out = gl.getOut();
		GLXOut.stag(out, "STRUCTURE", 0);
		dumpSchemaRowset(gl, doc.getDocumentElement(), 1);
		GLXOut.etag(out, "STRUCTURE", 0);
	}

	private void
	dumpSchemaNode(GLContext gl, Node n, String fullname, int depth)
		throws GLException, IOException
	{
		String name = ((Element) n).getAttribute("name");
		String type = ((Element) n).getAttribute("type");
		JspWriter out = gl.getOut();

		if ("attribute".equals(type)) {
			GLXOut.stag(out, "FIELD", depth);
			GLXOut.oneElement(out, "NAME",
				GLXML.addPath(fullname, "@"+name),
				1+depth);
			GLXOut.etag(out, "FIELD", depth);
		}
		else if ("element".equals(type)) {
			GLXOut.stag(out, "FIELD", depth);
			GLXOut.oneElement(out, "NAME",
				GLXML.addPath(fullname,
					("[body]".equals(name)) ? "." : name),
				1+depth);
			if ("[body]".equals(name)) {
				GLXOut.oneElement(out, "FRIENDLYNAME",
				    "".equals(fullname) ? "[body]" : fullname,
				    1+depth);
			}
			GLXOut.etag(out, "FIELD", depth);
		}
		else if ("rowset".equals(type)) {
			GLXOut.stag(out, "FIELD", depth);
			GLXOut.oneElement(out, "NAME",
				GLUtils.replace(
					GLXML.addPath(fullname, name),
					"/", "."),
				1+depth);
			GLXOut.stag(out, "STRUCTURE", 1+depth);
			dumpSchemaRowset(gl, (Element) n, 1+depth);
			GLXOut.etag(out, "STRUCTURE", 1+depth);
			GLXOut.etag(out, "FIELD", depth);
		}
		else if ("structure".equals(type)) {
			Node[] children = GLXML.getNodes(n, "*");
			fullname = GLXML.addPath(fullname, name);
			for (int i = 0; i < children.length; ++i)
				dumpSchemaNode(gl, children[i], fullname,
					depth);
		}
		else if ("hidden-attribute".equals(type))
			;
		else if ("hidden-element".equals(type))
			;
		else {
			throw new GLException(
				"Unknown NODE type "+type+" for "+name);
		}
	}

	private void
	dumpSchemaRowset(GLContext gl, Element node, int depth)
		throws GLException, IOException
	{
		Node[] children = GLXML.getNodes(node, "*");
		/* Process each child in turn. */
		/* XXX TODO always start with fullname=""? */
		for (int i = 0; i < children.length; ++i)
			dumpSchemaNode(gl, children[i], "", depth);
	}

	/**
	 * Puts DATA into a datasource description file designated by DSTYPE.
	 * This is a crude implementation; should use 1867 upload or similar
	 * to avoid char encoding problems.
	 */
	private void
	putDataSource(GLContext gl, String dstype, String data)
		throws Exception
	{
		File file = CSWXML.getDataSourceFile(gl, dstype);
		Writer bw = null;

		try {
			bw = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(file), "utf-8"));
			bw.write(data);
		}
		finally {
			try { bw.close(); } catch (IOException e) {}
		}
	}

	private static final String UQNAME =
		GLUtils.GL_PREFIX + "xml.info6.jsp#uq";
 %>
