<?php
$GLparam = array(
	/*
	 * Arrange to send data in the UTF-8 charset.
	 */
	'output_encoding'=>'UTF-8',
	'content_type'=>'text/xml',
);
require_once("../include/utils.runtime6.php");
require_once("../include/mysql.runtime6.php");

//*****************************************************************************
//
// info/mysql.info6.php
//
// GoLive design-time support for MySQL datasources.
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
// 
// NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
// License Agreement, Adobe permits you to reproduce and distribute this 
// file only as an integrated part of a web site created with Adobe 
// GoLive software and only for the purpose of enabling your client to 
// display their web site. All other terms of the Adobe license 
// agreement remain in effect.

//-----------------------------------------------------------------------------
// Return an XML document containing information about the MySQL datasources 
// known to the server.	 Requests served by this page:
//
// mysql.info6.php?datasources=<all|distinct>
//	<DATASOURCES>
//		<DATASOURCE>database_name
// 
// mysql.info6.php?db=Magazine
//	<DATATYPES>
//		<DATATYPE>
//			<TYPE_NAME>
//			<WHEREABLE>
//			<LITERAL_PREFIX>
//			<LITERAL_SUFFIX>
// 
// mysql.info6.php?db=Magazine&types=*
//	<TABLES>
//		<TABLE>table_name
// 
// mysql.info6.php?db=Magazine&sql=select+*+from+Projects
//	<COLUMNS>
//		<COLUMN>
//			<COLUMN_NAME>
//			<TYPE_NAME>
// 
// mysql.info6.php?db=Magazine&sql=select+*+from+Projects&records=1
// mysql.info6.php?db=Magazine&sql=select+*+from+Projects&records=1,100
//	<RECORDSET>
//		<RECORD NUMBER="recordnumber">
//			<FIELD COLUMN="fieldname">value</FIELD>
//
//  record numbering sequential starting at 1
//  records=N,K  means records from Nth to Kth inclusive 
//        i.e. 1,2 is 1st and 2nd
//             2,4 is 2nd, 3rd and 4th
//  records=N   is same as records=N,N   i.e. Nth record only
//  records=1,X  where X is very large gets all records.
// 
// mysql.info6.php?db=Magazine&sql=select+*+from+Projects&test=whatever
//	<TESTRESULT>
//		<RECORD>
//			<FIELD COLUMN="fieldname">value</FIELD>
//
// mysql.info6.php?db=Magazine&keys=Projects
//	<KEYS>
//		<PRIMARY_KEY>...
//
// mysql.info6.php?getsbs=<name>
//	 return raw content of mysql.sbs file
//   ex) mysql.info6.php?getsbs=Magazine
//
// mysql.info6.php?putsbs=<name>&data=<data>
//	 write raw content of mysql.sbs file
//   ex) mysql.info6.php?putsbs=Magazine&data=blah%20blah%20blah
//
// mysql.info6.php?delete=<name>
//	 deletes file
//   ex) mysql.info6.php?delete=Magazine.mysql.sbs
//

//-----------------------------------------------------------------------------
// Write out the list of available datasources.

function WriteDataSources($all)
{
	$handle = opendir(GetDataSourcePath());

	echo "<DATASOURCES>\r\n";
	while ($file = readdir($handle)) {
		if(ereg("(.*)\.mysql\.sbs", $file, $regs)){
			if ($all) {
				echo "\t<DATASOURCE>" . $file . "</DATASOURCE>\r\n";
			} else {
				echo "\t<DATASOURCE>" . $regs[1] . "</DATASOURCE>\r\n";
			}
		}
	}
	echo "</DATASOURCES>\r\n";
}

//-----------------------------------------------------------------------------
// Write out the list of datatypes.  MySQL doesn't support user-defined types, 
// so we just offer up a hard-coded list.

function WriteDatatypes($dsname)
{
?>
<DATATYPES>
	<DATATYPE>
		<TYPE_NAME>int</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX></LITERAL_PREFIX>
		<LITERAL_SUFFIX></LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>real</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX></LITERAL_PREFIX>
		<LITERAL_SUFFIX></LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>string</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>blob</TYPE_NAME>
		<WHEREABLE>False</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>date</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>time</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>datetime</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>timestamp</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
	<DATATYPE>
		<TYPE_NAME>unknown</TYPE_NAME>
		<WHEREABLE>True</WHEREABLE>
		<LITERAL_PREFIX>'</LITERAL_PREFIX>
		<LITERAL_SUFFIX>'</LITERAL_SUFFIX>
	</DATATYPE>
</DATATYPES>
<?php
}

//-----------------------------------------------------------------------------
// Write out the list of tables in 'dsname'.

function WriteTables($dsname, $linkId)
{
	global $GL_mysql_dsnames;
	$database = $GL_mysql_dsnames[$dsname]['database'];
	$result = mysql_list_tables($database, $linkId);

	echo "<TABLES>\r\n";
	for ($i = 0; $result && $i < mysql_num_rows($result); $i++) {
		echo "\t<TABLE>" . mysql_tablename($result, $i) . "</TABLE>\r\n";
	}
	echo "</TABLES>\r\n";

	if ($result)
		mysql_free_result($result);
}

//-----------------------------------------------------------------------------
// Write out the list of columns in the view returned by 'sql'.

function WriteColumns($dsname, $sql, $linkId)
{
	$result = mysql_query($sql, $linkId);

	echo "<COLUMNS>\r\n";
	while ($result && ($col = mysql_fetch_field($result))) {
		echo "\t<COLUMN>\r\n";
		echo "\t\t<COLUMN_NAME>" , $col->name , "</COLUMN_NAME>\r\n";
		echo "\t\t<TYPE_NAME>" , $col->type , "</TYPE_NAME>\r\n";
		echo "\t</COLUMN>\r\n";
	}
	echo "</COLUMNS>\r\n";

	if ($result)
		mysql_free_result($result);
}

//-----------------------------------------------------------------------------
// Write out the primary key of the table.

function WriteKeys($dsname, $table, $linkId)
{
	global $GL_mysql_dsnames;
	global $GL_strpos;
	$database = $GL_mysql_dsnames[$dsname]['database'];
	$result = mysql_list_fields($database, $table, $linkId);

	echo "<KEYS>\r\n";
	for ($i = 0; $result && $i < mysql_num_fields($result); $i++) {
		$flags = mysql_field_flags($result, $i);
		if ($GL_strpos($flags, "primary")) {
			echo "\t<PRIMARY_KEY>" . mysql_field_name($result, $i) . "</PRIMARY_KEY>\r\n";
		}
	}
	echo "</KEYS>\r\n";

	if ($result)
		mysql_free_result($result);
}


//-----------------------------------------------------------------------------
// Write out the results of a query.

function WriteResults($dsname, $sql, $records, $rootElement, $linkId)
{
	$result = mysql_query($sql, $linkId);

	$records = explode(",", $records);
	if ($result)
		mysql_data_seek($result, $records[0] - 1);
	$rownumber = $records[0];
	if (sizeof($records) > 1) {
		$counter = $records[1] + 1 - $records[0];
	} else {
		$counter = 1;
	}

	echo "<$rootElement>\r\n";
	while ($result && ($row = mysql_fetch_array($result)) && $counter-- > 0) {
		echo "\t<RECORD NUMBER=\"$rownumber\">\r\n";
		$rownumber++;
		$i = 0;
		while (list($fieldName, $value) = each($row)) {
			if ($i++ % 2) {	// skip numeric indexes...
				$encodedValue = xmlEncode($value);
				echo "\t\t<FIELD COLUMN=\"$fieldName\">$encodedValue</FIELD>\r\n";
			}
		}
		echo "\t</RECORD>\r\n";
	}
	echo "</$rootElement>\r\n";

	if ($result)
		mysql_freeGL_mysql_dsnames($result);
}


//-----------------------------------------------------------------------------
// Get mysq.sbs file.

function GetSBS($getsbs)
{
	setContentTypeHeader('text/plain');
	$filePath = GetDataSourcePath() . "$getsbs.mysql.sbs";
	if (!file_exists($filePath) || !is_file($filePath))
		return null;
	readfile($filePath);
}

//-----------------------------------------------------------------------------
// Put mysq.sbs file.

function PutSBS($putsbs, $data)
{
	$filePath = GetDataSourcePath() . "$putsbs.mysql.sbs";
//	if (!file_exists($filePath) || !is_file($filePath))
//		return null;
	$fp = fopen($filePath, "w"); 
	fwrite($fp, $data);
	fclose($fp);
}


//-----------------------------------------------------------------------------
// Delete file.
function Delete($delete)
{
	$filePath = GetDataSourcePath() . $delete;
	if (!file_exists($filePath) || !is_file($filePath))
		return null;
	unlink($filePath);
}


//-----------------------------------------------------------------------------
// MAIN

RejectUnauthorizedCallers();

$datasources= GetFormValue("datasources");
$ds			= GetFormValue("db");	// It is actually DataSource, but parameter is "db".
$types		= GetFormValue("types");
$sql		= GetFormValue("sql");
$records	= GetFormValue("records");
$test		= GetFormValue("test");
$keys		= GetFormValue("keys");
$getsbs		= GetFormValue("getsbs");
$putsbs		= GetFormValue("putsbs");
$data		= GetFormValue("data");
$delete		= GetFormValue("delete");

if ($ds != "_no_form_value") {
	$linkId = GL_mysql_connect($ds);
	if ($types != "_no_form_value") {
		WriteTables($ds, $linkId);
	} else if ($sql != "_no_form_value") {
		if ($test != "_no_form_value") {
			WriteResults($ds, $sql, "1,1", "TESTRESULT", $linkId);
		} else if ($records != "_no_form_value") {
			WriteResults($ds, $sql, $records, "RECORDSET", $linkId);
		} else {
			WriteColumns($ds, $sql, $linkId);
		}
	} else if ($keys != "_no_form_value") {
		WriteKeys($ds, $keys, $linkId);
	} else {
		WriteDatatypes($ds);
	}
	mysql_close($linkId);
} else {
	if ($getsbs != "_no_form_value") {
		GetSBS($getsbs);
	} else if ($putsbs != "_no_form_value") {
		PutSBS($putsbs, $data);
		if ($delete != "_no_form_value") {
			Delete($delete);
		}
	} else if ($delete != "_no_form_value") {
		Delete($delete);
	} else {
		WriteDataSources($datasources == "all");
	}
}


?>
