<?php

$GLparam = array(
	/*
	 * Arrange to send data in the UTF-8 charset.
	 */
	'output_encoding'=>'UTF-8',
	'content_type'=>'text/xml',
);
require_once("../include/utils.runtime6.php");

//
// Support for Customizable UI for DynamicLink
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
// 
// NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
// License Agreement, Adobe permits you to reproduce and distribute this 
// file only as an integrated part of a web site created with Adobe 
// GoLive software and only for the purpose of enabling your client to 
// display their web site. All other terms of the Adobe license 
// agreement remain in effect.
//

header("Content-type: text/xml; charset=utf-8");

$thisFilename = GetCurrentFile();

$packages = array();

$handle = opendir(dirname($thisFilename));
while ($file = readdir($handle)) {
	if (ereg('(.*)\.ui([0-9]+)\.xml$', $file, $regs)) {
		$thisPackageName = $regs[1];
		$thisPackageVersion = $regs[2];
		if ($thisPackageVersion > 100) {
			$thisPackageVersion /= 100;
		} else if ($thisPackageVersion > 10) {
			$thisPackageVersion /= 10;
		}

		if ($thisPackageVersion > 6.0) {
			continue;
		}

		if (isset($packages[$thisPackageName])) {
			$package = $packages[$thisPackageName];
			if ($thisPackageVersion > $package["version"]) {
				$package["version"] = $thisPackageVersion;
				$package["fullname"] = basename($file);
				$package["path"] = $file;
				$packages[$thisPackageName] = $package;
			}
		} else {
			$package = array();
			$package["name"] = $thisPackageName;
			$package["version"] = $thisPackageVersion;
			$package["fullname"] = basename($file);
			$package["path"] = $file;
			$packages[$thisPackageName] = $package;
		}
	}
}
closedir($handle);

echo "<ui6>\r\n\r\n";
while (list(, $package) = each($packages)) {
	echo "\r\n\r\n<!-- " . $package["fullname"] . " -->\r\n\r\n";
	readfile($package["path"]);
}
echo "</ui6>\r\n";

?>
